C	PLUTO.FTN
C
	PROGRAM PLUTO
C
C	PLUTO : SAM MOTHERWELL
C	MARK II VERSION : BILL CLEGG
C
	IMPLICIT INTEGER*2 (I-N)
C
	PARAMETER (NATMAX=150,NSCR=7*NATMAX+24)
C
	COMMON /XYZ/ VP(4096)
C
	COMMON /A/ NAME(NATMAX,6),X(NATMAX,3),RADI(NATMAX),INCL(NATMAX),
     *             ILAB(NATMAX),ITYPE(NATMAX),ICOL(NATMAX),IC(500),NAT,
     *             NATOS,NATO,NC,NC1,IERR
C
	COMMON /LABELS/ XL(NATMAX),YL(NATMAX)
C
	COMMON /SCRAT/ SCR(NSCR)
C
	COMMON /B/ ID(74),MOL(100,4),
     *             IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,ISTER,IPERS,
     *             ISOL,TAPER,ITRACE,ICOPY,IPLOTR,CHSIZE,SIZEM,SCA,
     *             DPLOT,S,ITRACH,ITRACV,TRLAB,ISHADE,ANG1,ANG2,SHADEN,
     *             PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,NMOL1
C
	COMMON /CELL/ ACELL,BCELL,CCELL,ALF,BET,GAM,OR1,OR2,OR3,OR4,OR5,
     *                OR6,D100,D010,D001
C
	COMMON /SYM/ RS(24,3,4),NSYM,ICENT
C
	COMMON /DEF/ RBDEF,LBDEF,RADEF,SZDEF,CHDEF,DPDEF,TDEF,
     *               RBDEFN,LBDEFN,ANGDF1,ANGDF2,SHADEF,TAPDEF,TLDEF,
     *               TRDEF,PLDEF,ZLIM,DEYE,RATIO
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,COL(40),FL(20,6),FN(20),
     *               NCHAR,KN,KL
C
	COMMON /E/ IENC,ENC(6)
C
	COMMON /ALPHA/ LET(27)
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     *               NPLOT,IXD,IYD,IPFIL(6),IPSIZ,MODEL
C
	INTEGER*2 FL,COL,TTO,TTI, NAMX(6)
C
C	ASCII-CODE  A-Z,BLANK
	DATA LET / 65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
     *             81,82,83,84,85,86,87,88,89,90,32 /
C
	DATA TTO,TTI,INP,IPL,IECHO / 5,5,1,2,5 /
C
C		INITIALISE
C
	NCHAR=6
	NPLOT=0
	ICOUNT=1
	NPL=0
	IERR=0
	XR=0.
	YR=0.
	ZR=0.
C
	MODEL=0
	CALL PLSTAR
	IDO=1
	CALL ZSETUP (IDO)
	YLIM=ZLIM
C
C		READ AND INTERPRET INPUT UP TO FIRST PLOT INSTRUCTION
C
1	CALL PLIN1 (ICOUNT,ICOM)
	IF (ICOM.EQ.10) GOTO 90
	CALL PLIN2 (ICOUNT,ICOM)
	CALL PLIN3 (ICOUNT,ICOM)
	IF (ICOM.NE.29) GOTO 1
	IF (IERR.EQ.0) GOTO 110
	IERR=0
	GOTO 1
C
C		INITIALISE FOR PLOTTING
C
110	WRITE (TTO,2)
2	FORMAT (' ** BEGIN PLOTTING **')
	IF (IECHO.NE.TTO) WRITE (IECHO,2)
	IDO=2
	CALL ZSETUP (IDO)
	IF (IDO.EQ.0) GOTO 1
	YLIM=ZLIM
	SIZEM=0.0
	CALL ZSETPN (1)
	NPL=NPL+1
	NCOPY=0
	PMAX=-1.0E10
	PMIN= 1.0E10
	XMAX=PMAX
	YMAX=PMAX
	XMIN=PMIN
	YMIN=PMIN
	ZMAX=-1000.
	ZMIN=1000.
	WRITE (TTO,4) ((R(I,J),  J=1,3),I=1,3)
4	FORMAT (/' VIEW ROTATION MATRIX'//3(9X,3F10.5/))
	IF (IECHO.NE.TTO) WRITE (IECHO,4) ((R(I,J),J=1,3),I=1,3)
D	WRITE (TTO,*) ' NATO,NMOL,ICELL =', NATO,NMOL,ICELL
	R11=R(1,1)
	R12=R(1,2)
	R13=R(1,3)
	R21=R(2,1)
	R22=R(2,2)
	R23=R(2,3)
	R31=R(3,1)
	R32=R(3,2)
	R33=R(3,3)
	NAP=0
	XR=0.
	YR=0.
	ZR=0.
	IF (NMOL.GT.0)  GOTO 5
	MOL(1,1)=1
	MOL(1,2)=0
	MOL(1,3)=0
	MOL(1,4)=0
	NMOL=1
C
C		BUILD UP ARRAY OF PLOT COORDS
C		BEGIN LOOP ON MOLECULE LIST
C
5	DO 11  M=1,NMOL
	NA=MOL(M,1)
	N=IABS(NA)
	TX =FLOAT(MOL(M,2))
	TY =FLOAT(MOL(M,3))
	TZ =FLOAT(MOL(M,4))
	I1=9
	IF (M.EQ.1) I1=1
D	WRITE (TTO,*) 'M,I1,NA,TX,TY,TZ =', M,I1,NA,TX,TY,TZ
CD	WRITE(TTO,*) ((RS(N,LI,LJ),LJ=1,4),LI=1,3)
C
C		BEGIN LOOP ON ATOMS IN MOLECULE
	DO 10 I=I1,NAT
C		GENERATE  FRACTIONAL COORDS FIRST   XF,YF,ZF
	IOMIT=1
	IF (I.GE.9) GOTO 6
	XF=X(I,1)
	YF=X(I,2)
	ZF=X(I,3)
	GOTO 7
6	CONTINUE
	XX=X(I,1)
	YY=X(I,2)
	ZZ=X(I,3)
	ZF = RS(N,3,1)*XX + RS(N,3,2)*YY + RS(N,3,3)*ZZ + RS(N,3,4) + TZ
	YF = RS(N,2,1)*XX + RS(N,2,2)*YY + RS(N,2,3)*ZZ + RS(N,2,4) + TY
	XF = RS(N,1,1)*XX + RS(N,1,2)*YY + RS(N,1,3)*ZZ + RS(N,1,4) + TX
	IF (NA.GT.0) GOTO 7
	ZF=-ZF+TZ+TZ
	YF=-YF+TY+TY
	XF=-XF+TX+TX
C		TEST FOR ATOM OUTSIDE ENCLOSURE FOR PLOT
7	IF (IENC.EQ.0) GOTO 8
	IF (I.LE.8) GOTO 8
	IF (XF.LT.ENC(1) .OR. XF.GT.ENC(2)) GOTO 9
	IF (YF.LT.ENC(3) .OR. YF.GT.ENC(4)) GOTO 9
	IF (ZF.LT.ENC(5) .OR. ZF.GT.ENC(6)) GOTO 9
C		MAKE ORTHOGONAL
8	IOMIT=0
CD	WRITE (TTO,8001) I,INCL(I),XF,YF,ZF
	XOR = OR1*XF
	YOR = OR2*XF + OR3*YF
	ZOR = OR4*XF + OR5*YF + OR6*ZF
C		ROTATE THE ORTHOGONAL COORDS
	XR = R11*XOR + R12*YOR + R13*ZOR
	YR = R21*XOR + R22*YOR + R23*ZOR
	ZR = R31*XOR + R32*YOR + R33*ZOR
	IF (ICELL.NE.0) GOTO 801
	IF (I.LT.9) GOTO 9
	IF (INCL(I).LE.0 .AND. I.LE.NATO) GOTO 9
801	XMAX=AMAX1(XR,XMAX)
	YMAX=AMAX1(YR,YMAX)
	ZMAX=AMAX1(ZR,ZMAX)
	XMIN=AMIN1(XR,XMIN)
	YMIN=AMIN1(YR,YMIN)
CD	WRITE (TTO,8001) I,INCL(I),XR,YR,ZR
9	NAP=NAP+1
	IF (NAP.GT.1000) GOTO 12
	I4=4*NAP-3
	VP(I4)=XR
	VP(I4+1)=YR
	VP(I4+2)=ZR
	VP(I4+3)=RADI(I)
	IF (IOMIT.EQ.1) VP(I4+3)=-1.
10	CONTINUE
C		END OF LOOP ON ATOMS
11	CONTINUE
C		END OF LOOP ON MOLECULES
8001	FORMAT (2I5,3F10.4)
	GOTO 14
12	WRITE (TTO,13)
13	FORMAT (/' ** PLOT COORD LISTS FULL: TOO MANY ATOMS IN PLOT')
	IF (IECHO.NE.TTO) WRITE (IECHO,13)
	NPL=NPL-1
	GOTO 50
14	NATOT=NAP
C		GET ALL COORDS REFERRED TO CENTRE OF THE PLOT AS ORIGIN.
	XC=(XMIN+XMAX)*0.5
	YC=(YMIN+YMAX)*0.5
	XMAX=XMAX-XC
	XMIN=XMIN-XC
	YMAX=YMAX-YC
	YMIN=YMIN-YC
	I4=1
	DO 15 I=1,NATOT
	VP(I4)=VP(I4)-XC
	VP(I4+1)=VP(I4+1)-YC
	VP(I4+2)=VP(I4+2)-ZMAX
15	I4=I4+4
C		GET MAX AND MIN FOR PLOT BOUNDARIES ALLOWING A SAFETY MARGIN.
	PMAX=AMAX1(XMAX,YMAX)
	PMIN=AMIN1(XMIN,YMIN)
	RMAX=0.0
	IBOX=0
	DO 16 I=1,NAT
	IF (INCL(I).GT.0) RMAX=AMAX1(RMAX,RADI(I))
16	CONTINUE
	PMAX=PMAX+RMAX
	PMIN=PMIN-RMAX
	SIZEA=PMAX-PMIN
	IF (SCA.LT.0.001) GOTO 17
C		APPLY SCALE FACTOR GIVEN .  ( SCA MM/ANGSTROM)
	SIZEM=SIZEA*SCA
	S=SCA
	GOTO 18
C		CALCULATE SCALE FACTOR TO FIT DRAWING IN BOX OF SIDE SIZEM MM.
C		AND SCALE DOWN BY FACTOR 0.99 FOR SAFETY
17	IF (SIZEM.EQ.0.) SIZEM=YLIM-5.0-TSIZE
18	IF (ISTER.NE.0) SIZEM=0.5*SIZEM
	S=0.99*SIZEM/SIZEA
C		AND BY FACTOR PROVIDED IF BOX TO BE DRAWN
	IF (SHRINK.EQ.0.) GOTO 19
	IBOX=1
	S=S*SHRINK
19	DPL=DPLOT
	IF (ISTER.EQ.0 .AND. IPERS.EQ.0) DPL=10000.
	YMIN=2.
	YMAX=SIZEM+2.
	WRITE (TTO,20) SIZEA,SIZEM,S,DPL
20	FORMAT (' SIZE OF PLOTTING AREA =',F8.2,' ANGSTROMS =',F8.2,
     *' MM.'/' SCALE FACTOR =',F8.4,' MM/A',6X,
     *'PERSPECTIVE DISTANCE =',F10.1,' MM')
	IF (IECHO.NE.TTO) WRITE (IECHO,20) SIZEA,SIZEM,S,DPL
D	WRITE (TTO,*) 'SIZEA,SIZEM,S,SCA,SHRINK='
D	WRITE (TTO,*) SIZEA,SIZEM,S,SCA,SHRINK
	YY=YMAX+2.+TSIZE
	IF (YY.LE.YLIM) GOTO 22
	WRITE (TTO,21) YY,YLIM
21	FORMAT (/' ** PLOT PLUS TITLE REQUIRES WIDTH OF',F8.2,' MM.'/
     *'    MAXIMUM PERMITTED IS',F8.2,'MM.  PLOT ABANDONNED.')
	IF (IECHO.NE.TTO) WRITE (IECHO,21) YY,YLIM
	NPL=NPL-1
	GOTO 50
C		CONVERT COORDS TO MM
22	PMAX=SIZEM*0.5
	PMIN=-PMAX
	I4=1
	DO 23 I=1,NATOT
	IF (VP(I4+3).LT.0.) GOTO 23
	VP(I4)=VP(I4)*S
	VP(I4+1)=VP(I4+1)*S
	VP(I4+2)=VP(I4+2)*S
	VP(I4+3)=S*VP(I4+3)*DPL/(DPL-VP(I4+2))
	IF (ISOL.EQ.0) VP(I4+3)=0.
23	I4=I4+4
24	IF (NCOPY.EQ.0) GOTO 28
C		RESET COORDINATES FOR MULTIPLE COPY
	I4=1
	DO 27 I=1,NATOT
	VP(I4)=VP(I4)-PMAX
	VP(I4+1)=VP(I4+1)-PMAX-3.0
	IF (ISTER.EQ.0 .AND. IPERS.EQ.0) GOTO 27
	Q=DPL/(DPL-VP(I4+2))
	VP(I4+1)=VP(I4+1)/Q
	IF (ISTER.EQ.0) GOTO 26
	IF (IPLOTR.NE.4) VP(I4)=VP(I4)-SIZEM
	VP(I4)=(VP(I4)-DEYE)/Q+DEYE
	GOTO 27
26	VP(I4)=VP(I4)/Q
27	I4=I4+4
C
28	CONTINUE
C			DISABLE RED/GREEN STEREO
C	IF (IPLOTR.EQ.4 .AND. ISTER.EQ.1) CALL ZSETPN (1)
C	IF (IPLOTR.EQ.4 .AND. ISTER.EQ.2) CALL ZSETPN (2)
	IF (ISTER.EQ.0  .AND.  IPERS.EQ.0)  GOTO 32
C		IF STEREO OR PERSPECTIVE REQUIRED ADJUST CO-ORDINATES.
	I4=1
	DO 31 I=1,NATOT
	Q=DPL/(DPL-VP(I4+2))
	IF (ISTER.EQ.0) GOTO 30
	IF (ISTER.EQ.2) GOTO 29
C		STEREO COORDS FOR LEFT EYE VIEW
	VP(I4)=(VP(I4)+DEYE)*Q - DEYE
	VP(I4+1)=VP(I4+1)*Q
	GOTO 31
C		STEREO COORDS FOR RIGHT EYE VIEW
29	VP(I4)=(VP(I4)-PMAX+DEYE)/Q-DEYE
	VP(I4)=(VP(I4)-DEYE)*Q + DEYE
	GOTO 31
C		PERSPECTIVE ONLY
30	VP(I4)=VP(I4)*Q
	VP(I4+1)=VP(I4+1)*Q
31	I4=I4+4
C		GET COORDS FOR ATOM LABELS HERE
32	IF (ISTER.EQ.2) GOTO 33
	IF (NCOPY.GT.0) GOTO 33
	SC=S*RBDEF
	IF (ISOL.EQ.0) SC=.7
	CALL PLABEL (RATIO,PMAX,PMIN,SC)
C		ADJUST COORDS SO THAT ALL ARE IN RANGE 0 - SIZEM
33	IF (ISTER-1) 34,34,35
34	TX=PMAX
	TY=PMAX+3.0
	GOTO 36
35	TX=PMAX+SIZEM
	IF (IPLOTR.EQ.4) TX=PMAX
	TY=0.
36	I4=1
	DO 37 I=1,NATOT
	VP(I4)=VP(I4)+TX
	VP(I4+1)=VP(I4+1)+TY
37	I4=I4+4
	XMAX=PMAX+TX
	XMIN=PMIN+TX
C		PLOT TITLE
	CALL ZSETPN (1)
	IF (ISTER.EQ.2) GOTO 375
	CALL ZCHAR (TSIZE,RATIO)
	YY=YMAX+1.5
	I=1
	XX=TSIZE
	CALL ZDRAW (I,XX,YY)
D	WRITE (TTO,*) 'X,Y TITLE =',XX,YY
	I=ID(74)
	CALL ZWRITE (ID,I)
375	IF (IBOX.EQ.0) GOTO 38
C		DRAW BOX DEFINING THE LIMIT OF PLOTTING COORDS
	I=1
	CALL ZDRAW (I,XMIN,YMIN)
	I=2
	CALL ZDRAW (I,XMIN,YMAX)
	CALL ZDRAW (I,XMAX,YMAX)
	CALL ZDRAW (I,XMAX,YMIN)
	CALL ZDRAW (I,XMIN,YMIN)
38	CONTINUE
D	WRITE (TTO,*) '38: NATOT,IPERS,ISTER,ICELL='
D	WRITE (TTO,*) NATOT,IPERS,ISTER,ICELL
D	WRITE (TTO,*) 'NAT,NATO,NATOS=', NAT,NATO,NATOS
D	WRITE (TTO,*) 'XMIN,XMAX =', XMIN,XMAX
D	WRITE (TTO,*) 'YMIN,YMAX =', YMIN,YMAX
D	WRITE (TTO,*) 'PMIN,PMAX =', PMIN,PMAX
D	DO 2900 I=1,NAT
D	WRITE (TTO,2901) I,(NAME(I,J),J=1,6),(X(I,J),J=1,3),INCL(I)
D2900	CONTINUE
D2901	FORMAT (I4,2X,6A1,3F10.4,I6)
D	I4=1
D	DO 3000 I=1,NATOT
D	WRITE (TTO,3001) I,VP(I4),VP(I4+1),VP(I4+2),VP(I4+3)
D3000	I4=I4+4
D3001	FORMAT (I4,4F10.2)
C		PASS CONTROL TO SUBR. SOLID FOR PLOTTING CIRCLES AND BONDS
	CALL PLSOLI
C		LABELS PLOTTED HERE
	IF (ISTER.EQ.2) GOTO 43
	MXCOL=0
	DO 400 I=1,NAT
	IF (ICOL(I).GT.MXCOL) MXCOL=ICOL(I)
400	CONTINUE
	CALL ZCHAR (CHSIZE,RATIO)
	JCOL=0
410	JCOL=JCOL+1
	IF (JCOL.GT.MXCOL) GOTO 43
	DO 42 I=1,NAT
	IF (I.LT.9 .AND. ICELL.EQ.0) GOTO 42
	IF (ILAB(I).EQ.0 .OR. ICOL(I).NE.JCOL) GOTO 42
	IF (I.GE.9 .AND. I.LE.NATO .AND. INCL(I).LE.0) GOTO 42
	IF (VP(4*I).LT.0.) GOTO 42
	XLABL=XL(I)+PMAX
	XX=FLOAT(ITRACV)*TRLAB
	YLABL=YL(I)+PMAX+3.+XX*0.5+TRLAB
	XLABL=XLABL-FLOAT(ITRACH-1)*0.5*TRLAB
D	WRITE (TTO,401) I,XLABL,YLABL,(NAME(I,J),J=1,6)
D401	FORMAT (' LABEL',I3,2F10.2,3X,6A1)
	DO 41 K=1,ITRACH
	YLABL=YLABL-XX
	DO 40 L=1,ITRACV
	J=1
	CALL ZDRAW (J,XLABL,YLABL)
	DO 39 J=1,6
39	NAMX(J)=NAME(I,J)
	CALL ZSETPN (JCOL)
	J=6
	CALL ZWRITE (NAMX,J)
40	YLABL=YLABL+TRLAB
41	XLABL=XLABL+TRLAB
42	CONTINUE
	GOTO 410
C		TEST IF STEREO PAIR IS TO BE DRAWN
43	IF (ISTER.EQ.0)  GOTO 45
	ISTER=ISTER+1
	IF (ISTER.GT.2)  GOTO 44
	GOTO 28
44	ISTER=1
C		CONTROL OF NUMBER OF COPIES
45	NCOPY=NCOPY+1
	WRITE (TTO,46) NPL,IPFIL
46	FORMAT (/' COMPLETED DRAWING NO.',I3,6X,'PLOTFILE = ',6A2)
	IF (IECHO.NE.TTO) WRITE (IECHO,46) NPL,IPFIL
50	CALL PLEND
CC      IF (NCOPY.LT.ICOPY) GOTO 24
	GOTO 1
C		END OF JOB
90	WRITE (TTO,91)
91	FORMAT (/' STOP - PLUTO'/)
	CALL EXIT
	END
C
C
C
	SUBROUTINE PLBOND (IATOM,JATOM,NOBSC,TAPER,RBO,NLI,
     *                     PLINC,DPL,XSTART,YSTART,XEND,YEND,IEND)
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /XYZ/ VP(4096)
C
      COMMON /SCRAT/ IOBSC(100),ZAX(3),U1(3),U2(3),U3(3),DC(3),
     *P(3),Q(3)
C
D	COMMON /FR/ TTO
D	INTEGER*2 TTO
C
      DIMENSION V(50,2),W(50,2)
C
      I=IATOM
      N=JATOM
	I4=I*4-3
	N4=N*4-3 
      NN=1
      NEND=0
      IDOWN=0
      NBLINE=IABS(NLI)
	PLINK=0.2
C**** JUMP TO 8 FOR ATOM SHADING
      IF(N.EQ.0) GOTO 8
      XI=VP(I4)
      YI=VP(I4+1)
      ZI=VP(I4+2)
      XN=VP(N4)
      YN=VP(N4+1)
      ZN=VP(N4+2)
      RI=VP(I4+3)
      RN=VP(N4+3)
      DX=XN-XI
      DY=YN-YI
      DZ=ZN-ZI
      DXYZ=SQRT(DX**2+DY**2+DZ**2)
      RISQ=RI**2
      RNSQ=RN**2
      IF(NLI.LE.1 .OR. RBO.LT.0.001) GO TO 9
C**** SOLID BONDS ARE TO BE DRAWN
C**** GET BOND CENTRE LINE DIRECTION-COSINES
      U3(1)=DX/DXYZ
      U3(2)=DY/DXYZ
      U3(3)=DZ/DXYZ
      IF(ABS(U3(3)) .GT. 0.9999)  GO TO 31
      ZAX(1)=0.
      ZAX(2)=0.
      ZAX(3)=1.0
C**** SET UP COORD SYSTEM FOR THE SEMI-CIRCLE CROSS-SECTION OF BOND.
      CALL  VPROD(ZAX,U3,U1)
      CALL  VPROD(U3,U1,U2)
C**** GET BOND RADIUS AT ATOMS I AND N.
      IF(TAPER.EQ.0.) GOTO 1
      T=ABS(TAPER*U3(3))
      RB1=RBO*(1.+T)
      RB2=RBO*(1.-T)
      GOTO 2
1     RB1=RBO*DPL/(DPL-ZI)
      RB2=RBO*DPL/(DPL-ZN)
2     IF(RB1.GT.RI) RB1=RI-0.001
      IF(RB2.GT.RN)  RB2=RN-0.001
      RB1=AMAX1(RB1,0.0)
      RB2=AMAX1(RB2,0.0)
3     NLIN=0
      T=0.
      DELT=3.14159/FLOAT(NBLINE-1)
C**** SET UP POINTS ON SEMICIRCLE AT CENTRES OF ATOMS.
4     COST=COS(T)
      SINT=SIN(T)
      CX=RB1*COST
      CY=RB1*SINT
      P(1)=U1(1)*CX + U2(1)*CY
      P(2)=U1(2)*CX + U2(2)*CY
      P(3)=U1(3)*CX + U2(3)*CY
      P(1)=P(1)+XI
      P(2)=P(2)+YI
      P(3)=P(3)+ZI
C**** AND AGAIN FOR POINT Q.
      CX=RB2*COST
      CY=RB2*SINT
      Q(1)=U1(1)*CX + U2(1)*CY
      Q(2)=U1(2)*CX + U2(2)*CY
      Q(3)=U1(3)*CX + U2(3)*CY
      Q(1)=Q(1)+XN
      Q(2)=Q(2)+YN
      Q(3)=Q(3)+ZN
C**** GET DIRECTION COSINES FOR THIS LINE PQ.
      D1=Q(1)-P(1)
      D2=Q(2)-P(2)
      D3=Q(3)-P(3)
      D=SQRT(D1**2 + D2**2 + D3**2)
      DC(1)=D1/D
      DC(2)=D2/D
      DC(3)=D3/D
      DELX=DC(1)*PLINK
      DELY=DC(2)*PLINK
      DELZ=DC(3)*PLINK
C**** NOW FIND POINT WHERE LINE EMERGES FROM SPHERE OF ATOM I.
      E=SQRT(RISQ - RB1**2)
      XSTART=  P(1) + E*DC(1)
      YSTART = P(2) + E*DC(2)
      ZSTART = P(3) + E*DC(3)
      IF(NEND.EQ.0) GOTO 5
      V(NLIN+1,1)=XSTART
      V(NLIN+1,2)=YSTART
C**** TEST IF THIS POINT IS OBSCURED BY CIRCLE I
5     IF(ZSTART.GT.ZI) GOTO 7
C**** OBSCURED THEREFORE MOVE ALONG LINE TO CIRCUMFERENCE OF CIRCLE I
C**** OR OMIT POINT V
      IF(NEND.EQ.0) GOTO 6
      V(NLIN+1,1)=-1.
      GOTO 7
6     XSTART=XSTART+DELX
      YSTART=YSTART+DELY
      ZSTART=ZSTART+DELZ
      DX=XSTART-XI
      DY=YSTART-YI
      IF(DX**2 + DY**2  .LT. RISQ)  GO TO 6
C**** NOW GET THE END POINT OF THE LINE. ( INTERSECTION WITH SPHERE N.)
7     F=SQRT(RNSQ-RB2**2)
      XEND=Q(1)-F*DC(1)
      YEND=Q(2)-F*DC(2)
      IF(NEND.EQ.0) GOTO 10
      W(NLIN+1,1)=XEND
      W(NLIN+1,2)=YEND
      NLIN=NLIN+1
      IF(NLIN.GT.NBLINE) GOTO 23
      T=T+DELT
      GOTO 4
8     DX=XEND-XSTART
      DY=YEND-YSTART
      DL=SQRT(DX**2+DY**2)
	NSTEP=INT(DL/0.2)
	IF (NSTEP.EQ.0) NSTEP=1
	DINC=DL/FLOAT(NSTEP)
      DELX=DX/FLOAT(NSTEP)
      DELY=DY/FLOAT(NSTEP)
      GOTO 12
C**** SINGLE LINE BOND TO BE DRAWN
9     NLIN=0
C**** GET DIRECTION COSINES OF BOND IN XY PLANE  BL,BM
      DXY=SQRT(DX**2+DY**2)
      BL=DX/DXY
      BM=DY/DXY
C**** GET THE STARTING POINT WHICH IS ON THE CIRCUMFERENCE OF CIRCLE I
      XSTART=XI + BL*RI
      YSTART=YI + BM*RI
C**** NOW GET THE END POINT FOR THE BOND
      XEND=XN - RN*DX/DXYZ
      YEND=YN - RN*DY/DXYZ
      DELX=BL*PLINK
      DELY=BM*PLINK
C**** START PLOTTING THE LINE XSTART-XEND
10    NLIN=NLIN+1
C**** WE JUMP IF THE BOND IS COMPLETELY OBSCURED BY THE ATOM I
      X=XEND-XI
      Y=YEND-YI
      IF(X**2+Y**2.LE.RISQ) GOTO 21
      IF(NN.GT.0) GOTO 11
      X=XSTART
      XSTART=XEND
      XEND=X
      X=YSTART
      YSTART=YEND
      YEND=X
      DELX=-DELX
      DELY=-DELY
11    DXL=XEND-XSTART
      DYL=YEND-YSTART
      DL=SQRT(DXL**2+DYL**2)
      DINC=SQRT(DELX**2+DELY**2)
12    X=XSTART
      Y=YSTART
      IF(NOBSC.EQ.0) GO TO 20
D	WRITE (TTO,*) 'NOBSC,XSTART,YSTART=', NOBSC,XSTART,YSTART
D	WRITE (TTO,*) 'XEND,YEND    =', XEND,YEND
D	WRITE (TTO,*) 'DX,DY,DL,DELX,DELY,DINC ='
D	WRITE (TTO,*) DX,DY,DL,DELX,DELY,DINC
C**** START OF TESTING FOR OBSCURING BY ATOMS K
13    I4=I*4-3
      IF(NOBSC.EQ.0) GOTO 15
      DO 14 L=1,NOBSC
      J=IOBSC(L)
      K=IABS(J)
	K4=K*4-3
      IF(NEND.EQ.2) J=K
      RK=VP(K4+3)
      RK=RK**2
      DXK=X-VP(K4)
      DXK=DXK**2
      DYK=Y-VP(K4+1)
      DYK=DYK**2
      RK=RK-DXK-DYK
      IF(RK.LT.0.) GOTO 14
      IF(J.GT.0) GOTO 16
      RI=VP(I4+3)
      RI=RI**2
      DXI=X-VP(I4)
      DXI=DXI**2
      DYI=Y-VP(I4+1)
      DYI=DYI**2
      RI=RI-DXI-DYI
      IF(RI.LT.0.) GOTO 16
      RI=SQRT(RI)+VP(I4+2)
      RK=SQRT(RK)+VP(K4+2)
      IF(RK.GT.RI) GOTO 16
14    CONTINUE
C**** NO OBSCURING .  GO AHEAD WITH THIS STEP
C**** IDRAW SIGNALS WHETHER TO DRAW THE LINE AT THE CURRENT POINT
C**** (0/1 FOR NO/YES)
C**** IDOWN RECORDS THE APPARENT STATUS OF THE PEN = 0/1 FOR UP/DOWN
15    IF(NEND.GE.1) GOTO 27
      IDRAW=1
      GOTO 17
C**** LIFT PEN WHEN OBSCURING FOUND
16    IF(NEND.GE.1) GOTO 26
      IDRAW=0
17    IF(DL.LE.0.0) IDRAW=0
      IF(IDRAW.EQ.0) GO TO 18
      IF(IDOWN.EQ.1) GO TO 19
C**** NOTE THE STARTING POINT OF A LINE SEGMENT AT THIS POINT (XA,YA).
      XA=X
      YA=Y
      IDOWN=1
      GO TO 19
C**** OBSCURING OCCURS AT THIS POINT. DRAW LINE SEGMENT (XA,YA) TO (X,Y)
C**** THEN LIFT THE PEN.
18    IF(IDOWN.EQ.0) GO TO 19
D	IF (NOBSC.GT.0) WRITE (TTO,*) '18: XA,YA,XE,YE,DL ='
D	IF (NOBSC.GT.0) WRITE (TTO,*) XA,YA,X,Y,DL
      L=1
      CALL ZDRAW(L,XA,YA)
      L=2
      CALL ZDRAW(L,X,Y)
      IDOWN=0
C**** TEST FOR END OF BOND LINE.
19    IF(DL.LE.0.0) GO TO 21
      X=X+DELX
      Y=Y+DELY
      DL=DL-DINC
      GO TO 13
C**** SIMPLE CASE OF THERE BEING NO OBSCURING ATOMS. DRAW LINE I TO N
20    L=1
      CALL ZDRAW(L,XSTART,YSTART)
      L=2
      CALL ZDRAW(L,XEND,YEND)
21    CONTINUE
      IF(NLI.LE.1 .OR. RBO.LE. 0.001) GO TO 31
      IF(NLIN.GE.NBLINE) GOTO 22
C**** DRAW NEXT LINE IN REVERSE DIRECTION
      T=T+DELT
      NN=-NN
      GOTO 4
C**** DRAW ENDS OF SOLID BOND
22    IF(IEND.EQ.0) GOTO 31
      NBLINE=INT(RB2*20.)
      IF(NBLINE.LT.2) GOTO 31
      NBLINE=MIN0(NBLINE,49)
      NEND=1
C**** SET UP POINTS AT BOND ENDS
      GOTO 3
C**** PLOT NEAR END IF VISIBLE
23    I=0
      IDOWN=0
24    I=I+1
      IF(I.GT.NBLINE) GOTO (28,31),NEND
      X=V(I,1)
      Y=V(I,2)
      GOTO (25,30),NEND
25    IF(X.LT.0.) GOTO 26
      GOTO 13
26    IDOWN=0
      GOTO 24
27    J=IDOWN+1
      CALL ZDRAW(J,X,Y)
      IDOWN=1
      GOTO 24
C**** PLOT FAR END
28    DO 29 I=1,NBLINE
      V(I,1)=W(I,1)
29    V(I,2)=W(I,2)
      NEND=2
      GOTO 23
30    XEND=X-XI
      YEND=Y-YI
      IF(XEND**2+YEND**2.LE.RISQ) GOTO 26
      GOTO 13
31    RETURN
      END

      SUBROUTINE PLCIRC (IATOM,NOBSC,ISHADE,ANG1,ANG2,DPLOT,
     *SHADEN,PLSTEP,TRSTEP,ITRACE)
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /XYZ/ VP(4096)
C
      COMMON /SCRAT/ IOBSC(100),U1(3),U2(3),U3(3),ZAX(3)
C
      PI=3.14159
C*** DRAW THE CIRCLE REPRESENTING THE SPHERE PROJECTED ON XY PLANE.
C*** SET UP NUMBER OF STRAIGHT-LINE SEGMENTS
	IAT4=IATOM*4-3
	XPIAT=VP(IAT4)
	YPIAT=VP(IAT4+1)
	ZPIAT=VP(IAT4+2)
	RPIAT=VP(IAT4+3)
      XCENT=XPIAT
      YCENT=YPIAT
      RADIUS=RPIAT
      X=2.*PI*RADIUS/PLSTEP+1.
      IF(NOBSC.EQ.0) X=10.5*SQRT(RADIUS)
      M=X
      M=MAX0(M,10)
      DTH=2.0*PI/FLOAT(M)
      CX=COS(DTH)
      SX=SIN(DTH)
      CY=1.
      SY=0.
      NPP=M+1
C**** NOW PLOT THE CIRCLE AS THE SEQUENCE OF NPP POINTS
      NTRACE=0
      INS=0
      JIN=0
      IUP=1
      I=0
1     I=I+1
      IF(I.GT.NPP) GOTO 8
      X=CY*RADIUS+XCENT
      Y=SY*RADIUS+YCENT
      IF(NOBSC.EQ.0) GO TO 6
      Z=ZPIAT
C**** THIS SECTION TESTS FOR THE OBSCURING OF THE POINT (X,Y,Z) BY ANY
C**** OF THE ATOMS GIVEN IN THE ARRAY IOBSC. IF THERE IS INTERSECTION
C**** OF SPHERE, THE NEGATIVE IS GIVEN OF THE ATOM SERIAL NUMBER.
2     DO 4  N=1,NOBSC
      J=IOBSC(N)
      J=IABS(J)
	J4=J*4-3
      DX=X-VP(J4)
      RJ=VP(J4+3)
      IF(ABS(DX).GT.RJ) GO TO 4
      DY=Y-VP(J4+1)
      IF(ABS(DY).GT.RJ) GO TO 4
      DSQ=DX**2 + DY**2
      RJSQ=RJ**2
C**** POINT IS OBSCURED WHEN WITHIN ENVELOPE CIRCLE J AND ZJ.GT.Z
      IF(DSQ.LT.RJSQ .AND. VP(J4+2).GT.Z) GO TO 5
      IF(IOBSC(N)) 3,4,4
C**** POINT IS OBSCURED IF WITHIN SPHERE J.
3     IF(J.EQ.JIN) GO TO 4
      DZ=Z-VP(J4+2)
      DSQ=DSQ+DZ**2
      IF(DSQ.LT.RJSQ) GO TO 5
4     CONTINUE
C**** NO OBSCURING SO GO AHEAD WITH PLOTTING OF THIS STEP.
      GO TO 6
C**** AN OBSCURING ATOM HAS BEEN FOUND .  LIFT THE PEN.
5     IUP=1
      GO TO 7
C**** PEN DOWN AND PLOT THIS STEP.
6     J=2
      IF(IUP.EQ.1) J=1
      CALL ZDRAW(J,X,Y)
      IUP=0
C**** NEXT POINT OF CIRCLE
7     X=CY*CX-SY*SX
      SY=SY*CX+CY*SX
      CY=X
      IF(INS)1,1,14
C**** END OF CIRCLE : RETRACE IF REQUESTED
8     IUP=1
      NTRACE=NTRACE+1
      I=0
      RADIUS=RADIUS-TRSTEP
      IF(NTRACE.LT.ITRACE) GOTO 1
C**** DRAW CIRCLES SHOWING THE SECTION OF OVERLAP OF SPHERES.
      INS=1
      RADIUS=RPIAT
      IF(NOBSC.EQ.0) GOTO 16
      NN=1
9     IF(IOBSC(NN)) 10,15,15
10    J=-IOBSC(NN)
	J4=J*4-3
      ZAX(1)=0.
      ZAX(2)=0.
      ZAX(3)=1.
C**** TESTS TO AVOID DRAWING EACH INTERSECTION MORE THAN ONCE
      IF(ZPIAT.LT.VP(J4+2)) GO TO 15
      DX=VP(J4) - XPIAT
      DY=VP(J4+1)-YPIAT
      DZ=VP(J4+2)-ZPIAT
C**** GET THE DISTANCE ALONG LINE IJ OF THE PLANE OF THE INTERSECTION.
C**** THIS IS CALCULATED BY SIMPLE COSINE FORMULA.
      DSQ=DX**2 + DY**2 + DZ**2
      DIJ=SQRT(DSQ)
      RI=RPIAT
      RJ=VP(J4+3)
      DIN=(RI**2 + DSQ - RJ**2)/(2.0*DIJ)
      RIN=RI**2-DIN**2
      IF(RIN.LE.0.) GOTO 15
      RIN=SQRT(RIN)
C**** DIRECTION COSINES OF VECTOR IJ
      U3(1)=DX/DIJ
      U3(2)=DY/DIJ
      U3(3)=DZ/DIJ
      XB=XPIAT + U3(1)*DIN
      YB=YPIAT + U3(2)*DIN
      ZB=ZPIAT + U3(3)*DIN
C**** THE INTERSECTION CIRCLE HAS CENTRE AT (XB,YB,ZB) AND RADIUS RIN.
C**** SET UP AXIAL SYSTEM WITH U3 ALONG DIRECTION IJ. THE CIRCLE IS
C**** GENERATED AS COORDINATES  (XX,YY,0)
      IF(ABS(U3(3)).LT.0.9999) GOTO 11
      U1(1)=1.
      U1(2)=0.
      U1(3)=0.
      GOTO 12
11    CALL  VPROD(ZAX,U3,U1)
12    CALL  VPROD(U3,U1,U2)
C**** CALCULATE POINTS ON CIRCLE USING THETA FROM 0 TO PI.
      JIN=J
      CY=1.
      SY=0.
      IP=1
13    XX=CY*RIN
      YY=SY*RIN
      X=U1(1)*XX + U2(1)*YY  + XB
      Y=U1(2)*XX + U2(2)*YY  + YB
      Z=U1(3)*XX + U2(3)*YY  + ZB
C**** NOW PLOT THIS POINT TESTING FOR OBSCURING AS BEFORE.
      IF(Z.LT.ZPIAT) GOTO 5
      GO TO 2
C**** AFTER PLOTTING ADD INCREMENT TO THETA.
14    IP=IP+1
      IF(IP.LE.NPP) GOTO 13
C**** END OF CIRCLE
      IUP=1
15    NN=NN+1
      IF(NN.LE.NOBSC) GOTO 9
C**** DRAW SHADE LINES ON SURFACE OF SPHERE. LIGHT SOURCE AT YROT,ZROT
C**** GIVEN BY (ANG1,ANG2)
16    IF(ISHADE.EQ.0.OR.ISHADE.EQ.2) GOTO 20
      JIN=0
      NPP=NPP/2
      IF(ITRACE.GT.1) RADIUS=RADIUS-FLOAT(ITRACE)*TRSTEP
      YS=-RADIUS
      RADIAN=180.0/PI
      A=ANG1/RADIAN
      B=ANG2/RADIAN
      CA=COS(A)
      CB=COS(B)
      SB=SIN(B)
      NN=1
C**** ONCE THROUGH THIS LOOP FOR EACH SHADING LINE TO BE DRAWN
C**** INNER LOOP TO RETRACE SHADE LINES
17    DO 19 I=1,ITRACE
      RSQ=RADIUS**2 -YS**2
      IF(RSQ.LT.0.1) GO TO 19
      R1=SQRT(RSQ)
C**** SET UP END-POINTS OF LINE
      X=CB*CA*R1+SB*YS+XCENT
      Y=-SB*CA*R1+CB*YS+YCENT
      XX=-CB*R1+SB*YS+XCENT
      YY=SB*R1+CB*YS+YCENT
      IF(NN.GT.0) GOTO 18
      Z=X
      X=XX
      XX=Z
      Z=Y
      Y=YY
      YY=Z
18    CALL PLBOND (IATOM,0,NOBSC,0.,0.,1,PLSTEP,DPLOT,
     *X,Y,XX,YY,0)
C**** END OF LOOP FOR SHADING
      NN=-NN
19    YS=YS+TRSTEP
      YS=YS-TRSTEP
      YS=YS+SHADEN
      IF(YS.LT.RADIUS) GOTO 17
C**** MARK ATOM CENTRE WITH A CROSS
20    IF(ISHADE.LT.2) GOTO 21
      I=1
      CALL ZDRAW(I,XCENT,YCENT)
      CALL ZMARK (XCENT,YCENT)
21    RETURN
      END

C		PLDSC.FTN
C
      SUBROUTINE DSCAN (MODE,IUNIQ,INTER,IPRINT)
C
	IMPLICIT INTEGER*2 (I-N)
C
	PARAMETER (NATMAX=150)
C
	COMMON /XYZ/ VP(4096)
C
      COMMON /A/ NAME(NATMAX,6),X(NATMAX,3),RADI(NATMAX),INCL(NATMAX),
     *ILAB(NATMAX),ITYPE(NATMAX),ICOL(NATMAX),IC(500),NAT,NATOS,NATO,
     *NC,NC1,IERR
C
      COMMON /B/ ID(74),MOL(100,4),
     *IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,ISTER,IPERS,ISOL,TAPER,
     *ITRACE,ICOPY,IPLOTR,CHSIZE,SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,
     *ISHADE,ANG1,ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,NMOL1
C
      COMMON/CELL/ACELL,BCELL,CCELL,ALF,BET,GAM,OR1,OR2,OR3,OR4,OR5,OR6,
     *D100,D010,D001
C
      COMMON /SYM/ RS(24,3,4),NSYM,ICENT
C
      COMMON /FR/  TTO,TTI,INP,IPL,IECHO,COL(40),FL(20,6),FN(20),
     *NCHAR,KN,KL
C
      COMMON /SCRAT/ NAMX(6),IDONE(NATMAX),KFIX(NATMAX),INEXT(NATMAX),
     *AXIS(3),KEY(3),DLIM(3),XI(3),
     *XJS(3),T(3),CMIN(3),CMAX(3),CENT(3),SEP(3),SGA(25,9),NSGA
C
      INTEGER*2 FL,TTO,TTI,COL
C
	LOGICAL*1 ECHO
C
      DATA  IBLANK,ISTAR,IAND /32,42,38/
C
	ECHO=(IECHO.NE.TTO)
      IF (MODE.EQ.999) GOTO 23
C**** FIND MOLECULES HAVING THEIR CENTRE WTHIN THE RANGE GIVEN
      CMIN(1)=FN(1)
      CMAX(1)=FN(2)
      CMIN(2)=FN(3)
      CMAX(2)=FN(4)
      CMIN(3)=FN(5)
      CMAX(3)=FN(6)
      NMOL=NMOL1
      DO 2 K=1,3
      C1=1.0E10
      C2=-C1
      DO 1 I=9,NATO
      C=X(I,K)
      C1=AMIN1(C1,C)
1     C2=AMAX1(C2,C)
      SEP(K)=(C1+C2)/2.0
2     CENT(K)=SEP(K)
      IF (MODE.EQ.0) GOTO 3
      CENT(1)=X(MODE,1)
      CENT(2)=X(MODE,2)
      CENT(3)=X(MODE,3)
3     WRITE (TTO,4) CENT
4     FORMAT (/' MOLECULAR CENTRE IS AT',3F8.4)
      IF (ECHO) WRITE (IECHO,4) CENT
      IF (NMOL.EQ.0) GOTO 7
      I4=1
      DO 6 I=1,NMOL
      XX=FLOAT(ISIGN(1,MOL(I,1)))
      N=IABS(MOL(I,1))
      DO 5 K=1,3
      XI(K)=XX*RS(N,K,4)+FLOAT(MOL(I,K+1))
      DO 5 J=1,3
5     XI(K)=XI(K)+RS(N,K,J)*SEP(J)*XX
      VP(I4)=XI(1)
      VP(I4+1)=XI(2)
      VP(I4+2)=XI(3)
6     I4=I4+4
7     XX=CENT(1)
      YY=CENT(2)
      ZZ=CENT(3)
      DO 18 N=1,NSYM
      NB=N
      BB=1.
      DO 8 K=1,3
8     XI(K) = RS(N,K,1)*XX + RS(N,K,2)*YY + RS(N,K,3)*ZZ + RS(N,K,4)
9     T(1)=0.
      T(2)=0.
      T(3)=0.
      K=1
10    IF (XI(K).LT.CMIN(K)) GOTO 11
      XI(K)=XI(K)-1.0
      T(K)=T(K)-1.0
      GOTO 10
11    XI(K)=XI(K)+1.0
      T(K)=T(K)+1.0
      IF (XI(K).GT.CMAX(K)) GOTO 16
      K=K+1
      IF (K.LE.3) GOTO 10
C**** CHECK FOR DUPLICATION OF MOLECULES IN THE LIST
      IF (NMOL.EQ.0) GOTO 14
      DO 12 L=1,3
      CENT(L)=BB*RS(N,L,4)+T(L)
      DO 12 J=1,3
12    CENT(L)=RS(N,L,J)*SEP(J)*BB+CENT(L)
      I4=1
      DO 13 I=1,NMOL
      IF (ABS(CENT(1)-VP(I4))+ABS(CENT(2)-VP(I4+1))+
     *ABS(CENT(3)-VP(I4+2)).LE.0.01) GOTO 15
13    I4=I4+4
      IF (NMOL.GE.100) GOTO 21
14    NMOL=NMOL+1
      MOL(NMOL,1)=NB
      MOL(NMOL,2)=T(1)
      MOL(NMOL,3)=T(2)
      MOL(NMOL,4)=T(3)
      I4=4*NMOL-3
      VP(I4)=CENT(1)
      VP(I4+1)=CENT(2)
      VP(I4+2)=CENT(3)
15    K=K-1
      GOTO 11
16    K=K-1
      IF (K.GT.0) GOTO 11
      IF (ICENT.EQ.0) GOTO 18
      IF (NB.LT.0) GOTO 18
      NB=-NB
      BB=-1.
      DO 17 K=1,3
17    XI(K)=-RS(N,K,1)*XX-RS(N,K,2)*YY-RS(N,K,3)*ZZ-RS(N,K,4)
      GOTO 9
18    CONTINUE
19    WRITE (TTO,20) NMOL
20    FORMAT (I4,' MOLECULES WITHIN SPECIFIED RANGE')
      IF (ECHO) WRITE (IECHO,20) NMOL
      GOTO 95
21    WRITE (TTO,22)
22    FORMAT (' ** MOLECULE LIST FULL BEFORE SEARCH COMPLETE')
      IF (ECHO) WRITE (IECHO,22)
      GOTO 19
C**** AUTOMATIC SEARCH FOR CONNECTIONS
23    IF (NMOL.GT.0 .AND. INTER.EQ.1) GOTO 24
      MOL(1,1)=1
      MOL(1,2)=0
      MOL(1,3)=0
      MOL(1,4)=0
      NMOL=1
      IF (IUNIQ.EQ.1) NMOL1=1
      NATOS=NATO
24    NAT=NATOS
      NRES=1
      NSP=0
      NOM=0
      MOVE=0
      MARK=IAND
      IF (INTER.EQ.1) GOTO 25
      MARK=ISTAR
      NC1=12
25    NC=NC1
      INTER=INTER+IUNIQ
      NC2=NC
C**** DECIDE ORDER OF AXES IN DESCENDING AXIAL LENGTH.
      AXIS(1)=ACELL
      AXIS(2)=BCELL
      AXIS(3)=CCELL
      IF (ACELL.EQ.BCELL .OR. ACELL.EQ.CCELL)  AXIS(1)=ACELL+.0002
      IF (BCELL.EQ.CCELL) AXIS(2)=BCELL+.0001
      AXHI=AMAX1(AXIS(1),AXIS(2),AXIS(3))
      AXLO=AMIN1(AXIS(1),AXIS(2),AXIS(3))
      DO 28 K=1,3
      IF (AXIS(K).EQ.AXHI) GOTO 26
      IF (AXIS(K).EQ.AXLO)  GOTO 27
      KEY(K)=2
      GOTO 28
26    KEY(K)=1
      GOTO 28
27    KEY(K)=3
28    CONTINUE
      KX=KEY(1)
      KY=KEY(2)
      KZ=KEY(3)
      DO 29 I=9,NATMAX
      IDONE(I)=0
      KFIX(I)=0
      INEXT(I)=0
29    CONTINUE
      NSG=0
      I=9
C**** START LOOP ON ATOM I
30    KFIX(I)=MAX0(KFIX(I),1)
      IF (INCL(I).EQ.0) GOTO 65
      XI(KX)=X(I,1)
      XI(KY)=X(I,2)
      XI(KZ)=X(I,3)
C**** START LOOP ON ATOMS J
      J=9
31    IF (INCL(J).EQ.0) GOTO 64
      DMAX=VP(4*I)+VP(4*J)
      DMAXSQ=DMAX*DMAX
C**** SET UP THE D LIMITS FOR EACH AXIS
      DLIM(KX)=DMAX/D100
      DLIM(KY)=DMAX/D010
      DLIM(KZ)=DMAX/D001
C**** START LOOP ON SYMMETRY OPERATORS
      DO 63 N=1,NSYM
      XCENT=1.
      NN=1
32    NNN=N*NN
      IF (INTER.EQ.0 .AND. NNN.NE.1) GOTO 64
      XX=X(J,1)
      YY=X(J,2)
      ZZ=X(J,3)
      XF = RS(N,1,1)*XX + RS(N,1,2)*YY + RS(N,1,3)*ZZ + RS(N,1,4)
      YF = RS(N,2,1)*XX + RS(N,2,2)*YY + RS(N,2,3)*ZZ + RS(N,2,4)
      ZF = RS(N,3,1)*XX + RS(N,3,2)*YY + RS(N,3,3)*ZZ + RS(N,3,4)
      XF=XF*XCENT
      YF=YF*XCENT
      ZF=ZF*XCENT
      XJS(KX)=XF
      XJS(KY)=YF
      XJS(KZ)=ZF
C**** BEGIN TRANSLATIONAL SEARCH ROUTINE.
      T(1)=0.
      T(2)=0.
      T(3)=0.
      K=1
      IF (INTER.EQ.1) GOTO 34
C**** NO CALCULATION OF INTERMOLECULAR DISTANCES.
      IF (I.EQ.J) GOTO 62
      DO 33 K=1,3
      SEP(K)=XI(K)-XJS(K)
      IF (ABS(SEP(K)).GT.DLIM(K)) GOTO 62
33    CONTINUE
      GOTO 38
C**** TRANSLATE XJS ON AXIS K TO A POINT BELOW LOWER LIMIT.
34    IF (XI(K)-XJS(K) .GT.DLIM(K))  GOTO 35
      XJS(K)=XJS(K)-1.0
      T(K)=T(K)-1.0
      GOTO 34
C**** ADVANCE +1.0 ON AXIS K.
35    XJS(K)=XJS(K)+1.0
      T(K)=T(K)+1.0
      SEP(K)=XJS(K) - XI(K)
      IF (SEP(K).LT. -DLIM(K)) GOTO 35
C**** TEST IF XJS-XI LESS THAN OR EQUAL TO DLIM(K)
      IF (SEP(K).GT.DLIM(K))  GOTO 36
      GOTO 37
C**** TEST GIVES ATOM OUT OF RANGE. REDUCE AXIS K BY 1.
36    K=K-1
      IF (K) 61,61,35
C**** K=0 SIGNALS THE END OF THE SEARCH
C**** IF XJS WAS WITHIN RANGE ON AXIS K THEN WE ADVANCE K BY 1
37    K=K+1
      IF (K.LE.3)  GOTO 34
C**** ATOM IN RANGE FOR ALL 3 AXES. NOW CALCULATE EXACT DISTANCE.
      IT=INT(ABS(T(KX)) + ABS(T(KY)) + ABS(T(KZ)))
C**** ELIMINATE DISTANCE OF ATOM FROM ITSELF.
      IF (NNN.EQ.1 .AND. IT.EQ.0 .AND. I.EQ.J) GOTO 39
      IF (IUNIQ.EQ.1) GOTO 38
      IF (INTER.EQ.0) GOTO 38
C**** ELIMINATE INTRAMOL DISTS IF INTERMOL SEARCH ONLY
      IF (NNN.EQ.1 .AND. IT.EQ.0) GOTO 39
38    DXO=OR1*SEP(KX)
      DYO=OR2*SEP(KX) + OR3*SEP(KY)
      DZO=OR4*SEP(KX) + OR5*SEP(KY) + OR6*SEP(KZ)
      DIJSQ=DXO*DXO + DYO*DYO + DZO*DZO
      IF (DIJSQ.LE.DMAXSQ)  GOTO 40
39    K=K-1
      IF (INTER.EQ.0) GOTO 62
      GOTO 35
C**** WE HAVE A DISTANCE LESS THAN OR EQUAL TO DMAX. STORE CONNECTION
40    DIJ=SQRT(DIJSQ)
      XJST=XJS(KX)
      YJST=XJS(KY)
      ZJST=XJS(KZ)
      IF (DIJ.GT.0.05)  GOTO 48
      IF (J.GT.NAT) GOTO 39
      KFIX(J) = MAX0(KFIX(J),1)
      IDONE(J) = 1
      IF (I.EQ.J) GOTO 47
C**** DELETE SYMMETRY-EQUIVALENT ATOM
      IF (KFIX(J).EQ.2) MOVE=MOVE-1
      INEXT(J)=0
      L=12
45    L=L+1
      IF (L.GT.NC) GOTO 46
      IL=IC(L)/256
      IF (IL.LE.0) IL=IL+255
      IF (IL-J) 41,42,46
41    IL=MOD(IC(L),256)
      IF (IL.LE.0) IL=IL+255
      IF (IL.NE.J) GOTO 45
42    NC=NC-1
      IF (L.GT.NC) GOTO 44
      DO 43 NSGA=L,NC
43    IC(NSGA)=IC(NSGA+1)
44    IF (IUNIQ.NE.INTER .AND. L.LE.NC1) NC1=NC1-1
      GOTO 45
46    KFIX(J)=I
      NOM=NOM+1
      GOTO 62
C**** ATOM IN SPECIAL POSITION
47    INCL(I)=ISIGN(NATMAX,INCL(I))+INCL(I)
      IF (IUNIQ.EQ.1) NSP=NSP+1
      GOTO 39
C**** DECIDE WHAT TO DO WITH THIS CONNECTION.
48    KAT=J
      NEW=1
      IF (INTER.EQ.0) GOTO 58
      IF (IUNIQ.EQ.0) GOTO 51
C**** UNIQUE MODE ONLY
      IF (IDONE(J).EQ.0)  INEXT(J)=1
      ITX=0
      IF (NNN.EQ.1 .AND. IT.EQ.0) ITX=1
      IF (ITX*KFIX(J).GE.1) GOTO 57
      IF (KFIX(J).GE.1) GOTO 49
      KFIX(J)=MAX0(KFIX(J),1)
      IF (ITX.EQ.1) GOTO 57
C**** MOVE ATOM J
      X(J,1)=XJST
      X(J,2)=YJST
      X(J,3)=ZJST
      KFIX(J)=2
      MOVE=MOVE+1
      GOTO 57
C**** TEST FOR SYMMETRY GENERATED ATOM J'
49    XX=X(I,1)
      YY=X(I,2)
      ZZ=X(I,3)
      XF=(RS(N,1,1)*XX+RS(N,1,2)*YY+RS(N,1,3)*ZZ+RS(N,1,4))*XCENT+T(KX)
      YF=(RS(N,2,1)*XX+RS(N,2,2)*YY+RS(N,2,3)*ZZ+RS(N,2,4))*XCENT+T(KY)
      ZF=(RS(N,3,1)*XX+RS(N,3,2)*YY+RS(N,3,3)*ZZ+RS(N,3,4))*XCENT+T(KZ)
      IF (ABS(XX-XF).GT.0.0001) GOTO 50
      IF (ABS(YY-YF).GT.0.0001) GOTO 50
      IF (ABS(ZZ-ZF).GT.0.0001) GOTO 50
      NEW=0
50    IF (ABS(X(J,1) -XJST) .GT. 0.0001)  GOTO 51
      IF (ABS(X(J,2)-YJST) .GT. 0.0001)  GOTO 51
      IF (ABS(X(J,3)-ZJST) .GT. 0.0001)  GOTO 51
      GOTO 57
C**** ADD ATOM TO LIST
C**** THE EXTRA ATOMS ARE USED FOR DRAWING BONDS BETWEEN MOLECULES. THE
C**** CIRCLES ARE NOT TO BE DRAWN HOWEVER.
C**** TEST FOR DUPLICATION OF ATOM COORDS IN LIST.
51    IF (NEW.EQ.0) GOTO 55
      NATC=NAT+NSG
      DO 52 L=9,NATC
      IF (ABS(X(L,1)-XJST).LT.0.0001 .AND. ABS(X(L,2)-YJST).LT.0.0001
     *.AND. ABS(X(L,3)-ZJST).LT.0.0001) GOTO 39
52    CONTINUE
      NSG=NSG+1
      KAT=NATOS+NSG
      IF (KAT.GT.NATMAX) GOTO 96
      X(KAT,1)=XJST
      X(KAT,2)=YJST
      X(KAT,3)=ZJST
      NAMX(1)=NAME(J,1)
      DO 53 L=2,6
      NAMX(L)=NAME(J,L)
53    IF (NAME(J,L).EQ.IBLANK .AND. NAME(J,L-1).NE.IBLANK)NAMX(L)=MARK
      DO 54 L=1,6
54    NAME(KAT,L)=NAMX(L)
      INCL(KAT)=(1-J)*IUNIQ-INTER
      IF (IUNIQ.EQ.1) INCL(J)=ISIGN((IABS(INCL(J))/NATMAX)*NATMAX+
     2                        KAT,INCL(J))
      ILAB(KAT)=ILAB(J)
      ITYPE(KAT)=ITYPE(J)
      ICOL(KAT)=ICOL(J)
      RADI(KAT)=RADI(J)
      VP(4*KAT)=VP(4*J)
C**** ADD MOLECULE TO LIST
55    ITX=T(KX)
      ITY=T(KY)
      ITZ=T(KZ)
      DO 56 MM=1,NMOL
      IF (MOL(MM,1).EQ.NNN .AND. MOL(MM,2).EQ.ITX .AND. MOL(MM,3).EQ.ITY
     *.AND. MOL(MM,4).EQ.ITZ)  GOTO 58
56    CONTINUE
      IF (NMOL.GE.100) GOTO 100
      NMOL=NMOL+1
      IF (IUNIQ.EQ.1) NMOL1=NMOL
      MOL(NMOL,1)=NNN
      MOL(NMOL,2)=ITX
      MOL(NMOL,3)=ITY
      MOL(NMOL,4)=ITZ
C**** ADD CONNECTION TO LIST
57    CONTINUE
58    IF (I.GT.KAT) GOTO 39
      IF (NEW.EQ.0) GOTO 39
      L=256*I+KAT
      IF (NC.LT.13) GOTO 60
      DO 59 LL=13,NC
      IF (L.EQ.IC(LL)) GOTO 39
59    CONTINUE
60    IF (NC.GE.500) GOTO 98
      NC=NC+1
      IC(NC)=L
      GOTO 39
C**** END OF TRANSLATIONAL SEARCH
61    CONTINUE
C**** END LOOP ON SYMMETRY OPERATORS.
62    IF (ICENT.EQ.0 .OR. NN.LT.0) GOTO 63
      XCENT=-1.
      NN=-1
      GOTO 32
63    CONTINUE
C**** END OF LOOP ON ATOMS J
64    J=J+1
      IF (J.LE.NAT) GOTO 31
C**** NOW DECIDE WHAT TO DO ABOUT THE NEXT ATOM I
65    IF (IUNIQ.EQ.0) GOTO 71
66    IDONE(I)=1
      INEXT(I)=0
      DO 67 IL=9,NAT
      IF (INEXT(IL).EQ.1)  GOTO 70
67    CONTINUE
C**** NO CONNECTED ATOM IS LEFT TO GOTO THEREFORE WE BEGIN A NEW
C**** RESIDUE, UNLESS ALL ATOMS HAVE BEEN DONE
      DO 68 IL=9,NAT
      IF (IDONE(IL).EQ.0)  GOTO 69
68    CONTINUE
      GOTO 72
C**** SET THE NEXT ATOM I FOR CALCULATION
69    NRES=NRES+1
70    I=IL
      GOTO 30
C**** ADVANCE I TO I+1 IF NOT UNIQUE MODE
71    I=I+1
      IF (I.GT.NAT)  GOTO 72
      GOTO 30
C**** END OF LOOP ON I
72    NSGA=NSG
      NAT=NATOS+NSGA
      IF (IUNIQ.EQ.1) NATOS=NAT
      IF (IUNIQ.EQ.INTER)NC1=NC
C**** PRINT OUT WHAT HAS BEEN FOUND
      IF (NOM.EQ.0) GOTO 76
      IF (IPRINT.EQ.0) GOTO 74
      WRITE (TTO,73)
73    FORMAT (/' THE FOLLOWING PAIRS OF ATOMS ARE SYMMETRY EQUIVALENT'/
     *' THE SECOND ATOM HAS BEEN DELETED IN EACH CASE')
      IF (ECHO) WRITE (IECHO,73)
74    DO 75 I=9,NATO
      IF (KFIX(I).LE.8) GOTO 75
      INCL(I)=0
      IF (IPRINT.EQ.0) GOTO 75
      J=KFIX(I)
      WRITE (TTO,90) (NAME(J,K),K=1,6),(NAME(I,K),K=1,6)
      IF (ECHO) WRITE (IECHO,90) (NAME(J,K),K=1,6),(NAME(I,K),K=1,6)
75    CONTINUE
76    IF (IPRINT.EQ.0) GOTO 93
      IF (MOVE.EQ.0) GOTO 80
      WRITE (TTO,77)
77    FORMAT (/' THE FOLLOWING ATOMS HAVE BEEN MOVED:')
      IF (ECHO) WRITE (IECHO,77)
      DO 79 I=9,NATO
      IF (KFIX(I).NE.2) GOTO 79
      WRITE (TTO,78) (NAME(I,K),K=1,6),X(I,1),X(I,2),X(I,3)
78    FORMAT (1X,6A1,4H TO ,3F10.5)
      IF (ECHO) WRITE (IECHO,78) (NAME(I,K),K=1,6),X(I,1),X(I,2),X(I,3)
79    CONTINUE
80    IF (NSP.EQ.0) GOTO 84
      WRITE (TTO,81)
81    FORMAT (/' THE FOLLOWING ATOMS ARE IN SPECIAL POSITIONS:')
      IF (ECHO) WRITE (IECHO,81)
      J=NATO
      IF (IUNIQ.NE.INTER) J=NATOS
      DO 83 I=9,J
      IF (IABS(INCL(I)).LT.NATMAX) GOTO 83
      WRITE (TTO,82) (NAME(I,K),K=1,6)
82    FORMAT (1X,6A1)
      IF (ECHO) WRITE (IECHO,82) (NAME(I,K),K=1,6)
83    CONTINUE
84    IF (NSGA.EQ.0)  GOTO 87
      WRITE (TTO,85)
85    FORMAT (/' THE FOLLOWING SYMMETRY-RELATED ATOMS HAVE BEEN'/
     *' GENERATED FOR CONNECTIONS BETWEEN MOLECULES:')
      IF (ECHO) WRITE (IECHO,85)
      J=NATO+1
      IF (IUNIQ.EQ.0) J=NATOS+1
      DO 86 I=J,NAT
      IF (ECHO) WRITE (IECHO,82) (NAME(I,L),L=1,6)
86    WRITE (TTO,82) (NAME(I,L),L=1,6)
87    WRITE (TTO,88)
88    FORMAT(/' THE FOLLOWING CONNECTIONS HAVE BEEN GENERATED:')
      IF (ECHO) WRITE (IECHO,88)
      IF (NC.EQ.NC2) GOTO 91
      M=NC2+1
      DO 89 K=M,NC
      I=IC(K)/256
      IF (I.LE.0) I=I+255
      J=MOD(IC(K),256)
      IF (J.LT.0) J=J+256
      IF (ECHO) WRITE (IECHO,90) (NAME(I,L),L=1,6),(NAME(J,L),L=1,6)
89    WRITE (TTO,90) (NAME(I,L),L=1,6),(NAME(J,L),L=1,6)
90    FORMAT (4X,6A1,2H--,6A1)
91    IF (NRES.EQ.1) GOTO 93
      WRITE (TTO,92) NRES
92    FORMAT (/' THERE ARE ',I3,' SEPARATE UNCONNECTED FRAGMENTS')
      IF (ECHO) WRITE (IECHO,92) NRES
93    WRITE (TTO,94)
94    FORMAT (/1X,32('='))
      IF (ECHO) WRITE (IECHO,94)
95    RETURN
96    WRITE (TTO,97)
97    FORMAT (/' ** ATOM LIST FULL BECAUSE OF SYMMETRY-GENERATED ATOMS')
      IF (ECHO) WRITE (IECHO,97)
      GOTO 102
98    WRITE (TTO,99)
99    FORMAT (/' ** CONNECTIONS LIST FULL BECAUSE OF SYMMETRY-',
     *'GENERATED ATOMS')
      IF (ECHO) WRITE (IECHO,99)
      GOTO 102
100   WRITE (TTO,101)
101   FORMAT (/' ** MOLECULE LIST FULL')
      IF (ECHO) WRITE (IECHO,101)
C**** SEARCH INTERRUPTED
102   WRITE (TTO,103)
103   FORMAT (/' ** SEARCH INTERRUPTED: ALL GENERATED ATOMS AND ',
     *'BONDS CANCELLED')
      IF (ECHO) WRITE (IECHO,103)
      NMOL=NMOL1
      NC=NC1
      NAT=NATOS
      RETURN
      END

	SUBROUTINE PLEND
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,BUF(80)
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     2               NPLOT,IXD,IYD,IPFIL(6),IPSIZ,MODEL
C
	INTEGER*2 TTO,TTI
C
	BYTE BUF,ENDT(14),END2(7),END3(4),END4(2),END5(4),ENDP(26)
C
	DATA ENDT / 27,'S','C',27,'L','Z',27,'L','V','1',
     2              27,'%','!','2' /
C
	DATA END2 / 27,'%','!','0',27,'L','Z' /
	DATA END3 / 27,'S','K','!' /
	DATA END4 / 27,12 /
	DATA END5 / 27,'%','!','2' /
C
	DATA ENDP / 'P','U',';','S','P','0',';','P','U',6*0,',',
     2              6*0,';',27,'.',')' /
C
	LPEN=0
	IF (ITERM.EQ.0) GOTO 50
C
	J=4
	IF (ITERM.GT.4105) J=1
	WRITE (TTO,10) (ENDT(I),I=J,14)
10	FORMAT ('+',80(A1,$))
	WRITE (TTO,12)
12	FORMAT (1X/' PRESS RETURN TO CONTINUE ',$)
	READ (TTO,13) J
13	FORMAT (A1)
	WRITE (TTO,10) END2
	IF (ITERM.GT.4105) WRITE (TTO,10) END3
	IF (ITERM.EQ.4105) WRITE (TTO,10) END4
	WRITE (TTO,10) END5
	RETURN
C
50	IX=0
	IY=0
	IF (IPSIZ.EQ.3) GOTO 55
	IX=NXMAX
	IY=NYMAX
55	ENCODE (6,56,ENDP(10)) IX
	ENCODE (6,56,ENDP(17)) IY
56	FORMAT (I6)
	WRITE (IPL,60) ENDP
60	FORMAT (80A1)
C
90	CLOSE (UNIT=IPL)
C
	RETURN
	END

-------------------------------------------------------------------------
C
C	GETSTR.FTN	GENERAL STRING INPUT ROUTINE
C
C-------------------------------------------------------------------------
C
C	INPUT :
C	=======
C
C		LUN	: LOGICAL UNIT NUMBER
C		AREA	: LOGICAL ARRAY TO RECEIVE THE STRING
C		MAXLEN	: MAXIMUM LENGTH OF THE STRING ( < 250 )
C
C
C	OUTPUT:
C	=======
C
C		ERR	: ERROR FLAG (LOGICAL)
C			  = .FALSE.  NO ERROR OCCURED
C			  = -1       END OF FILE UPON READ
C			  = -2       ANY OTHER READ ERROR
C			  = -3       STRING LONGER THAN MAXLEN
C
C------------------------------------------------------------------------
C
C
	SUBROUTINE GETSTR (LUN,AREA,MAXLEN,ERR)
C	=======================================
C
	IMPLICIT INTEGER*2 (I-N)
C
	LOGICAL*1 AREA(1),ERR
C
	ERR=0
	READ (LUN,9,END=1,ERR=2) ITMP,(AREA(I),I=1,ITMP)
	IF (MAXLEN.GT.0 .AND. ITMP.GT.MAXLEN) GOTO 3
	AREA(ITMP+1)=0
	CALL TRIM (AREA)
	RETURN
C
1	ERR=-1
	RETURN
2	ERR=-2
	RETURN
3	ERR=-3
	RETURN
9	FORMAT (Q,255A1)
	END

C--------------------------------------------------------------------------
C
C	TRIM.FTN	REMOVE TRAILING NULLS AND BLANKS FROM A STRING
C
C--------------------------------------------------------------------------
C
C
	SUBROUTINE TRIM (AREA)
C	======================
C
	IMPLICIT INTEGER*2 (I-N)
C
	LOGICAL*1 AREA(1)
C
	EXTERNAL LEN
C
	N=LEN(AREA)+1
10	N=N-1
	IF (N.LE.0) RETURN
	IF (AREA(N).EQ.32) AREA(N)=0
	IF (AREA(N).EQ.0) GOTO 10
C
	RETURN
	END

C------------------------------------------------------------------------
C
C	LEN.FTN		DETERMINE THE LENGTH OF A STRING
C
C------------------------------------------------------------------------
C
C
	INTEGER FUNCTION LEN (AREA)
C	===========================
C
	IMPLICIT INTEGER*2 (I-N)
C
	LOGICAL*1 AREA(1)
C
	N=0
10	N=N+1
	IF (AREA(N).NE.0.AND.N.LT.256) GOTO 10
	LEN=N-1
C
	RETURN
	END

C
	SUBROUTINE NOLOW (STR)
C	======================
C
C	Convert lower case characters to upper case
C
C
	IMPLICIT INTEGER*2 (I-N)
C
	LOGICAL*1 STR(1)
C
	EXTERNAL LEN
C
C
	NCH = LEN (STR)
	IF (NCH.EQ.0) RETURN
C
	DO 10 J=1,NCH
	IC=STR(J)
	IF (IC.GT."140.AND.IC.LT."173) STR(J)=IC-"40
10	CONTINUE
C
	RETURN
	END

      SUBROUTINE FREDA (KMIN,KMAX)
C
C**** FREE-FORMAT READING ROUTINE.
C**** RETURNS KN NUMBERS IN FN, KL LITERALS IN FL
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /FR/ TTO,TTI,INP,IPL,IECHO,COL(80),FL(20,6),FN(20),
     *              NCHAR,KN,KL
C
	INTEGER*2 FL,TTI,TTO,INUM(10)
C
	BYTE COL,ERR
C
	EXTERNAL LEN
C
C     ASCII-CODE 1,2..9   BL + - . = '
      DATA INUM/49,50,51,52,53,54,55,56,57,48/
      DATA IBLANK,IPLUS,IMINUS,IPOINT,IEQ,IQU/32,43,45,46,61,39/
C
	IMIN=KMIN
	IMAX=KMAX
      KN=0
      KL=0
      I=IMIN-1
C**** START OF A NEW FIELD
C**** LOOK FOR A NON-BLANK COLUMN
1     A=0.0
      IP=0
      P=1.
      L=0
      S=1.0
2     I=I+1
      IF (I.GT.IMAX)  GOTO 8
      ICH=COL(I)
      IF (L.EQ.0  .AND.  ICH.EQ.IBLANK)  GOTO 2
C**** START OF A FIELD
      L=L+1
      DO 3 J=1,10
      IF (ICH.EQ.INUM(J)) GOTO 4
3     CONTINUE
      IF (ICH.EQ.IPOINT)  GOTO 5
      IF (ICH.EQ.IPLUS)  GOTO 6
      IF (ICH.EQ.IMINUS)  GOTO 7
      IF (ICH.EQ.IEQ) GOTO 16
      IF (L.GT.1)  GOTO 9
      GOTO 10
C**** NUMERIC FIELD FOUND
4     IF (J.EQ.10)  J=0
      IF (IP.EQ.1)  P=P*0.1
      A=10.0*A + FLOAT(J)
      GOTO 2
5     IP=1
      GOTO 2
6     IF (L.GT.1)  GOTO 9
      S=1.0
      GOTO 2
7     IF (L.GT.1)  GOTO 9
      S=-1.0
      GOTO 2
8     IF (L.GT.0)  GOTO 9
      GOTO 19
C**** END OF NUMERIC FIELD
9     A=S*A*P
      IF (KN.GE.20) GOTO 20
      KN=KN+1
      FN(KN)=A
      IF (ICH.EQ.IPLUS .OR. ICH.EQ.IMINUS .OR. ICH.EQ.IEQ) I=I-1
      GOTO 1
C**** LITERAL FIELD
10    IF (KL.GE.20) GOTO 22
      KL=KL+1
11    FL(KL,L) = ICH
      IF (ICH.EQ.IQU) GOTO 12
      L=L+1
      IF (L.GT.NCHAR)  GOTO 13
12    I=I+1
      IF (I.GT.IMAX)  GOTO 14
      ICH=COL(I)
      IF (ICH.EQ.IBLANK)  GOTO 14
      GOTO 11
13    I=I+1
      IF (I.GT.IMAX) GOTO 19
      IF (COL(I).EQ.IBLANK) GOTO 1
      GOTO 13
C**** END OF LITERAL FIELD DEFINED BY BLANK
14    DO 15 J=L,NCHAR
15    FL(KL,J) = IBLANK
      GOTO 1
C**** CONTINUATION CARD
16    IF (L.GT.1) GOTO 9
	CALL GETSTR (INP,COL,80,ERR)
	IF (ERR.NE.0) GOTO 19
	NCH=LEN(COL)
D	WRITE (TTO,*) 'NCH=',NCH
	IF (INP.NE.TTI) WRITE (TTO,18) IBLANK,(COL(I),I=1,NCH)
18	FORMAT (80A1)
	IF (IECHO.NE.TTO) WRITE (IECHO,18) (COL(I),I=1,NCH)
	DO 181 I=NCH+1,80
181	COL(I)=IBLANK
      I=1
      IMAX=80
      GOTO 1
C**** FINISHED
19    RETURN
C**** ERRORS
20    WRITE (TTO,21)
21    FORMAT (' ** TOO MANY NUMBERS GIVEN: ONLY FIRST 20 ACCEPTED')
      IF (IECHO.NE.TTO) WRITE (IECHO,21)
      GOTO 19
22    WRITE (TTO,23)
23    FORMAT (' ** TOO MANY LITERALS GIVEN: ONLY FIRST 20 ACCEPTED')
      IF (IECHO.NE.TTO) WRITE (IECHO,23)
      GOTO 19
      END

      SUBROUTINE SYMFRE (COL,RS,NSYM,IERR)
C
C**** FREE-FORMAT READING ROUTINE FOR SYMM CARDS
C
	IMPLICIT INTEGER*2 (I-N)
C
      COMMON /FR/ TTO,TTI,INP,IPL,IECHO
C
      INTEGER*2 TTI,TTO
C
	BYTE COL(80),LCH, ERROR,ECHO
C
      DIMENSION RS(24,3,4),INUM(10)
C
C     ASCII-CODE  X Y Z + - . , * BL
      DATA IX,IY,IZ,IPLUS,IMINUS,IPOINT,ICOMMA,ISTAR,IBLANK/88
     *,89,90,43,45,46,44,42,32/
      DATA INUM/ 48,49,50,51,52,53,54,55,56,57 /
C
	ECHO=(IECHO.NE.TTO)
      DO 1 I=1,80
	II=I
	ICH=COL(I)
      IF (ICH.EQ.IBLANK) GOTO 2
1     CONTINUE
2     I=II
      IMAX=80
      NS=NSYM
3     NS=NS+1
      IF (NS.GT.24) GOTO 20
      NOP=1
      DO 4 J=1,3
      DO 4 K=1,4
4     RS(NS,J,K) = 0.0
5     S=1.0
      T=0.0
      IP=0
      P=1.
      IFOUND=0
6     I=I+1
      IF (I.GT.IMAX)  GOTO 18
      ICH = COL(I)
      IF (ICH.EQ.IBLANK)  GOTO 6
      IF (ICH.EQ.ICOMMA .OR. ICH.EQ.ISTAR) GOTO 18
      IFOUND=1
      IF (ICH.EQ.IX) GOTO 11
      IF (ICH.EQ.IY)  GOTO 12
      IF (ICH.EQ.IZ)  GOTO 13
      IF (ICH.EQ.IPLUS) GOTO 15
      IF (ICH.EQ.IMINUS)  GOTO 16
      IF (ICH.EQ.IPOINT)  GOTO 17
      DO 7 K=1,10
      IF (ICH.EQ.INUM(K))  GOTO 9
7     CONTINUE
      LCH=ICH
      WRITE (TTO,8) LCH,LCH
8     FORMAT (' ** ERROR - INVALID CHARACTER ... ',I4,2X,A1)
      IF (ECHO) WRITE (IECHO,8) LCH
      IERR=1
      GOTO 6
9	A = FLOAT(K-1)
      IF (IP.EQ.1)  GOTO 10
      T=10.0*T + A
      GOTO 6
10    P=P*0.1
      T=T+A*P
      GOTO 6
11    J=1
      GOTO 14
12    J=2
      GOTO 14
13    J=3
14    RS(NS,NOP,J) = S
      S=1.0
      GOTO 6
15    S=1.0
      GOTO 6
16    S=-1.0
      GOTO 6
17    IP=1
      GOTO 6
18    T=T*S
      RS(NS,NOP,4)=T
      ERROR = (IFOUND.EQ.0 .AND. I.LE.IMAX)
      IF (ERROR) WRITE (TTO,19)
19    FORMAT (' ** ERROR - BLANK OPERATOR FIELD')
      IF (ECHO.AND.ERROR) WRITE (IECHO,19)
      IF ( I.GT.IMAX)  GOTO 22
      NOP=NOP+1
      IF (NOP.LE.3) GOTO 5
      GOTO 3
20    WRITE (TTO,21)
21    FORMAT (' ** SYMM LIST FULL')
      IF (ECHO) WRITE (IECHO,21)
      GOTO 24
22    IF (NOP.EQ.1 .AND. IFOUND.EQ.0)  GOTO 24
      IF (NOP.EQ.3 .AND. IFOUND.EQ.1)  GOTO 25
      IERR=1
      WRITE (TTO,23)
23    FORMAT (' ** ERROR - LAST GENERAL POSITION IS INCOMPLETE')
      IF (ECHO) WRITE (IECHO,23)
24    NS=NS-1
25    NSYM=NS
      RETURN
      END

	SUBROUTINE PLIN1 (ICOUNT,ICOM)
C
	IMPLICIT INTEGER*2 (I-N)
C
	PARAMETER (NATMAX=150)
C
      COMMON /A/ NAME(NATMAX,6),X(NATMAX,3),RADI(NATMAX),INCL(NATMAX),
     *ILAB(NATMAX),ITYPE(NATMAX),ICOL(NATMAX),IC(500),NAT,NATOS,NATO,
     *NC,NC1,IERR
C
      COMMON /B/ ID(74),MOL(100,4),
     *IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,ISTER,IPERS,ISOL,TAPER,
     *ITRACE,ICOPY,IPLOTR,CHSIZE,SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,
     *ISHADE,ANG1,ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,NMOL1
C
      COMMON/CELL/ACELL,BCELL,CCELL,ALF,BET,GAM,OR1,OR2,OR3,OR4,OR5,OR6,
     *D100,D010,D001
C
      COMMON /E/ IENC,ENC(6)
C
      COMMON /SYM/ RS(24,3,4),NSYM,ICENT
C
      COMMON/DEF/ RBDEF,LBDEF,RADEF,SZDEF,CHDEF,DPDEF,TDEF,
     *RBDEFN,LBDEFN,ANGDF1,ANGDF2,SHADEF,TAPDEF,TLDEF,TRDEF,PLDEF
C
      COMMON /FR/  TTO,TTI,INP,IPL,IECHO,COL(80),FL(20,6),FN(20),
     *NCHAR,KN,KL
C
      COMMON /SCRAT/ PLINE(3),V1(3),V2(3),V3(3),R1(3),R2(3),A(3,3),
     *B(3,3),NAMX(6),FVAR(NATMAX)
C
      COMMON /ALPHA/ LA,LB,LC,LD,LE,LF,LG,LH,LI,LJ,LK,LL,LM,LN,LO,LP,
     *LQ,LR,LS,LT,LU,LV,LW,LX,LY,LZ,LBLANK
C
	BYTE COL,LCOM(4),ICCELL(24),FILNAM(30),ERR
C
	INTEGER*2 FL,TTO,TTI, LET(27),JCELL(8)
C
	REAL CMD(33)
C
	EQUIVALENCE (LA,LET(1)), (XCOM,LCOM(1))
C
	EXTERNAL LEN
C
C	INSTRUCTIONS
	DATA CMD / 'BEG ','CEL ','SYM ','ANG ','FRA ','ATO ','FVA ',
     *      'JOI ','TIT ','END ','VIE ','ALI ','SOL ','STI ','LAB ',
     *      'UNL ','PUT ','RAD ','PAC ','MOL ','INC ','OMI ','UNI ',
     *      'RET ','STE ','MON ','SIZ ','PRI ','PLO ','RES ','SEG ',
     *      'ECH ','COL ' /
	DATA NCOM / 33 /
C
C	ASCII-CODE '*'=42  '&'=38  '('=40 '0'=48  '1'=49  '9'=57
	DATA LSTAR,LAND,LPAR,L0,L1,L9 / 42,38,40,48,49,57 /
	DATA JCELL / 0,100,110,10,1,101,111,11 /
	DATA ICCELL/ 1,2, 2,3, 3,4, 4,1, 1,5, 5,6, 6,7, 7,8, 8,5,
     *               4,8, 7,3, 2,6 /
C
C**** INITIALISE
      RAD = 57.2958
      IF (ICOUNT.GT.1) GOTO 4
	WRITE (TTO,1000)
1000	FORMAT (//' ***   PLUTO  Rev 2.0   ***')
C**** SET CELL CORNER COORDINATES.
      DO 2 I=1,8
      ICOL(I)=1
      ILAB(I)=0
      INCL(I)=-1
      ITYPE(I)=0
      RADI(I)=0.
      X(I,1)=FLOAT(JCELL(I)/100)
      X(I,2)=FLOAT(MOD(JCELL(I)/10,10))
      X(I,3)=FLOAT(MOD(JCELL(I),10))
      DO 1 K=1,6
1     NAME(I,K)=LBLANK
2     CONTINUE
      NAME(1,1)=LO
      NAME(2,1)=LA
      NAME(4,1)=LB
      NAME(5,1)=LC
      ILAB(1)=1
      ILAB(2)=1
      ILAB(4)=1
      ILAB(5)=1
C**** SET UP CELL CONNECTIVITY HERE.
	I=1
	DO 3 K=1,12
	IC(K)=256*ICCELL(I)+ICCELL(I+1)
3	I=I+2
C
300	CONTINUE
	WRITE (TTO,301)
301	FORMAT (/' INPUT FILE ? ',$)
	DO 302 I=1,30
302	FILNAM(I)=0
	CALL GETSTR (TTI,FILNAM,25,ERR)
	NCH=LEN(FILNAM)
	IF (NCH.EQ.0) GOTO 312
	CALL NOLOW (FILNAM)
D	WRITE (TTO,304) FILNAM
D304	FORMAT (' FILNAM = ',30A1)
	INP=2
	OPEN (UNIT=INP,NAME=FILNAM,FORM='FORMATTED',TYPE='OLD',
     2        SHARED,READONLY,ERR=305)
	GOTO 4
305	WRITE (TTO,306)
306	FORMAT (/' ** INPUT FILE CANNOT BE OPENED')
	GOTO 300
C
310	CLOSE (UNIT=INP)
C	WRITE (TTO,*) 'NAT =',NAT
C	WRITE (TTO,311) ((NAME(I,J),J=1,6),(X(I,J),J=1,3),
C     2   RADI(I),ITYPE(I)/256,MOD(ITYPE(I),256),INCL(I),
C     3   ICOL(I),I=1,NAT)
C311	FORMAT (1X,6A1,3F8.4,F8.2,4I4)
312	INP=TTI
	WRITE (TTO,315)
315	FORMAT (/' ENTER INSTRUCTIONS')
C
C***** ALL DATA CARDS READ HERE
C
4	IF (INP.EQ.TTI) WRITE (TTO,401)
401	FORMAT (' ? ',$)
	CALL GETSTR (INP,COL,80,ERR)
	IF (ERR.EQ.-1) GOTO 310
	NCH=LEN(COL)
	IF (NCH.LT.3) GOTO 4
	CALL NOLOW (COL)
	DO 405 I=1,3
405	LCOM(I)=COL(I)
	LCOM(4)=LBLANK
	J1=COL(1)
	J2=COL(2)
	J3=COL(3)
D	WRITE (TTO,*) 'NCH,J1=', NCH,J1
	IF (INP.NE.TTI) WRITE (TTO,6) LBLANK,(COL(I),I=1,NCH)
	IF (IECHO.NE.TTO) WRITE (IECHO,6) (COL(I),I=1,NCH)
6	FORMAT (80A1)
	IF (J1.EQ.LBLANK) GOTO 4
	DO 406 I=NCH+1,80
406	COL(I)=LBLANK
C**** INTERPRET SETTING-UP INSTRUCTIONS
	DO 501 I=1,NCOM
	ICOM=I
	IF (XCOM.EQ.CMD(I)) GOTO 502
501	CONTINUE
	ICOM=0
502   	CONTINUE
D	WRITE (TTO,*) '502: ICOM =',ICOM
	CALL FREDA (1,80)
D	WRITE (TTO,*) 'FREDA : KL,KN =', KL,KN
D	IF (KN.GT.0) WRITE (TTO,*) (FN(I),I=1,KN)
D	IF (KL.GT.0) WRITE (TTO,504) ((FL(I,J),J=1,6),I=1,KL)
D504	FORMAT (1X,6A1)
	IF (ICOM.EQ.0) GOTO 510
	IF (ICOM.EQ.1) GOTO 22
	IF (ICOUNT.EQ.1) GOTO 23
7	IF (ICOM.EQ.33) GOTO 100
	IF (ICOM.EQ.30) GOTO 68
	IF (ICOM.EQ.32) GOTO 20
	IF (ICOM.GT.10) GOTO 900
	GOTO (22,27,28,34,35,38,36,180,66,247) ICOM
C
C**** PERHAPS UNFORMATTED ATOM CARD
C**** CHECK SYNTAX OF FIRST THREE COLS FOR ATOM NAME . THIS MUST BE A
C**** ONE OF TWO LETTER ELEMENT SYMBOL FOLLOWED BY A NUMBER, SPACE OR (.
510	M=0
8     K=0
      IF (J1.LT.LA .OR. J1.GT.LZ) GOTO 10
      IF (J2.GE.LA .AND. J2.LE.LZ) GOTO 9
      J3=J2
      J2=LBLANK
9     IF (J3.GE.L0 .AND. J3.LE.L9) GOTO 11
      IF (J3.EQ.LBLANK) GOTO 11
      IF (J3.EQ.LPAR) GOTO 11
10    IF (M.EQ.1) GOTO 12
      K=1
11    IF (M.EQ.1) GOTO 40
      IF (KN.EQ.3) GOTO 39
      IF (KN.GE.4) GOTO 16
C**** UNRECOGNISED - IGNORE THIS CARD
12    WRITE (TTO,13)
13    FORMAT (' ** UNRECOGNISED INSTRUCTION - IGNORED')
      IF (IECHO.NE.TTO) WRITE (IECHO,13)
      GOTO 4
C**** THIS IS CONSIDERED TO BE A CARD FROM SHEL-X PROGRAM
C**** SKIP THE FIRST NUMERIC FIELD WHICH IS THE FORMFACTOR NUMBER.
16    FN(1)=FN(2)
      FN(2)=FN(3)
      FN(3)=FN(4)
C**** INTERPRET FREE VARIABLES AND FIXED COORDS
      DO 19 K=1,3
      YY=FN(K)
      IF (YY.GT.-5.) GOTO 17
      YY=ABS(YY)
      Y=AINT((YY+5.)*0.1)
      I=INT(Y)
      IF (I.GT.NFVAR) GOTO 236
      YY=Y*10.-YY
      FN(K)=YY*(FVAR(I)-1.)
      GOTO 19
17    IF (YY.LT.5.) GOTO 19
      IF (YY.GT.15.) GOTO 18
      FN(K)=YY-10.
      GOTO 19
18    Y=AINT((YY+5.)*0.1)
      I=INT(Y)
      IF (I.GT.NFVAR) GOTO 236
      YY=YY-Y*10.
      FN(K)=YY*FVAR(I)
19    CONTINUE
      GOTO 39
C**** ECHO
20	IECHO=TTO
	IF (LN.EQ.2 .AND. FL(2,1).EQ.LN) GOTO 4
	IECHO=3
	OPEN (UNIT=IECHO,NAME='PLUTO.LOG',FORM='FORMATTED',
     2        CARRIAGECONTROL='LIST',TYPE='UNKNOWN',ERR=21)
	GOTO 4
21	WRITE (TTO,*) '** LOG-FILE ALREADY OPEN !?'
	GOTO 4
C**** BEGIN CARD
22    M=1
      N=1
23    DO 24 I=1,74
24    ID(I)=LBLANK
      ICOUNT=ICOUNT+1
      NAT=8
      NC=12
      NC1=12
      NMOL=0
      NMOL1=0
      MA=0
      NFVAR=0
      IERR=0
      ICENT=0
      NSYM=1
      DO 26 I=1,3
      DO 25 J=1,4
25    RS(1,I,J)=0.
26    RS(1,I,I)=1.
      IF (J1.NE.LB) GOTO 68
      GOTO 66
C**** CELL CONSTANTS
27    K=0
      IF (KN.LT.6) GOTO 236
      IF (KN.EQ.7) K=1
      ACELL=FN(K+1)
      BCELL=FN(K+2)
      CCELL=FN(K+3)
      ALF=FN(K+4)
      BET=FN(K+5)
      GAM=FN(K+6)
C**** ORTHOGONALISTION MATRIX OR1-6
      SA=SIN(ALF/RAD)
      SB=SIN(BET/RAD)
      SG=SIN(GAM/RAD)
      CA=COS(ALF/RAD)
      CB=COS(BET/RAD)
      CG=COS(GAM/RAD)
      CGSTAR= (CA*CB - CG)/(SA*SB)
      SGSTAR= SQRT(1.0 - CGSTAR**2)
      OR1=ACELL*SB*SGSTAR
      OR2= -ACELL*SB*CGSTAR
      OR3= BCELL*SA
      OR4=ACELL*CB
      OR5=BCELL*CA
      OR6= CCELL
C**** SET UP LIMITS FOR TESTING IF ATOM IN RANGE FOR DISTANCE CALCULATIO
      VOL=ACELL*BCELL*CCELL*SQRT(1.0-CA*CA-CB*CB-CG*CG+2.0*CA*CB*CG)
      D100=VOL/(BCELL*CCELL*SA)
      D010=VOL/(ACELL*CCELL*SB)
      D001=VOL/(ACELL*BCELL*SG)
      GOTO 4
C**** SYMMETRY CARD
28    IF (KL.EQ.2 .AND. FL(2,1).EQ.LC) GOTO 33
      IF (KL.GT.1) GOTO 32
      IF (KN.NE.12) GOTO 32
C**** THIS IS A NUMERICALLY CODED SYMMETRY OPERATOR.
      K=0
      IF (NSYM.GE.24) GOTO 30
      NSYM=NSYM+1
      DO 29 I=1,3
      DO 29 J=1,4
      K=K+1
29    RS(NSYM,I,J)=FN(K)
      GOTO 4
30    WRITE (TTO,31)
31    FORMAT (' ** SYMM LIST FULL: IGNORED')
      IF (IECHO.NE.TTO) WRITE (IECHO,31)
      GOTO 4
C**** THIS IS AN ALPHANUMERIC SYMMETRY CARD, LIKE INTERNAT. TABS.
32    CALL SYMFRE (COL,RS,NSYM,IERR)
      GOTO 4
33    ICENT=1
      GOTO 4
C**** ANGSTROM CARD
34    MA=1
      GOTO 4
C**** FRACTIONAL CARD
35    MA=0
      GOTO 4
C**** FVAR LIST
36    IF (KN.EQ.0) GOTO 236
      DO 37 I=1,KN
37    FVAR(NFVAR+I)=FN(I)
      NFVAR=NFVAR+KN
      GOTO 4
C**** ATOM AS FROM DATA FILE
38    IF (KN.NE.3) GOTO 236
      M=1
      J1=FL(2,1)
      J2=FL(2,2)
      J3=FL(2,3)
	DO 381 I=1,6
381	FL(1,I)=FL(2,I)
      GOTO 8
39    IF (KL.GT.2 .AND. FL(KL-1,1).EQ.LT) GOTO 45
      IF (K.EQ.1) GOTO 12
40    IF (NAT.GE.NATMAX) GOTO 46
      NAT=NAT+1
      NATO=NAT
      NATOS=NAT
      X(NAT,1)=FN(1)
      X(NAT,2)=FN(2)
      X(NAT,3)=FN(3)
      IF (MA.EQ.1) GOTO 41
      IF (M.EQ.0 .AND. (KL.EQ.1 .OR. FL(2,1).NE.LA)) GOTO 42
      IF (M.EQ.1 .AND. COL(45).NE.L1) GOTO 42
41    X(NAT,1)=X(NAT,1)/ACELL
      X(NAT,2)=X(NAT,2)/BCELL
      X(NAT,3)=X(NAT,3)/CCELL
42    DO 43 K=1,6
43    NAME(NAT,K)=FL(1,K)
C**** GET A CHARACTERISTIC NUMBER TO IDENTIFY ATOM TYPE LATER ON.
      I=NAT
      DO 44 J=1,27
      IF (J1.EQ.LET(J)) N1=J
      IF (J2.EQ.LET(J)) N2=J
44    CONTINUE
      ITYPE(I)=-(N1*256+N2)
      INCL(I)=1
      ILAB(I)=0
      ICOL(I)=1
      RADI(I)=RADEF
      GOTO 4
45    J1=FL(KL,1)
      J2=FL(KL,2)
      IF (J1.LT.LA .OR. J1.GT.LZ) GOTO 236
      IF ((J2.LT.LA .OR. J2.GT.LZ) .AND. J2.NE.LBLANK) GOTO 236
      GOTO 40
46    WRITE (TTO,47)
47    FORMAT (' ** ATOM LIST FULL: IGNORED')
      IF (IECHO.NE.TTO) WRITE (IECHO,47)
      GOTO 4
C**** TITLE FOR PLOT
66    IAN=1
	IEN=80
	DO 67 I=4,80
	IF(COL(I).NE.LBLANK) GOTO 67
	IAN=I+1
	GOTO 671
67	CONTINUE
671	DO 672 I=80,IAN,-1
	IF(COL(I).EQ.LBLANK) GOTO 672
	IEN=I
	GOTO 673
672	CONTINUE
673	IF((IEN-IAN+1).LE.73) GOTO 674
	IEN=71+IAN
	COL(IEN)=LSTAR
674	DO 675 I=IAN,IEN
675	ID(I-IAN+1)=COL(I)
	ID(74)=IEN-IAN+1
      IF (J1.EQ.LT) GOTO 4
C**** CLEAR FLAGS FOR PLOTTING AND SET UP DEFAULTS
68    NMOL=NMOL1
      IERR=0
      ISOL=0
      ISTER=0
      IPERS=0
      IAL=0
      NSPEC=0
      ICELL=0
      SCA=0.
      ITRACE=1
      ITRACH=1
      ITRACV=1
      TRLAB=TLDEF
      TRSTEP=TRDEF
      PLSTEP=PLDEF
      ICOPY=1
      IENC=0
      IPLOTR=1
      ISHADE=0
      ANG1=ANGDF1
      ANG2=ANGDF2
      TAPER=TAPDEF
      RBDEF=RBDEFN
      LBDEF=LBDEFN
      IEND=0
      SHRINK=0.
      TSIZE=TDEF
      DO 70 I=1,3
      DO 69 J=1,3
69    R(I,J)=0.
70    R(I,I)=1.
      SHADEN=SHADEF
      SIZEM=SZDEF
      CHSIZE=CHDEF
      DPLOT=DPDEF
      IF (J1.EQ.LB) GOTO 300
      IF (J1.NE.LR) GOTO 7
      DO 71 I=9,NAT
      RADI(I)=RADEF
      ILAB(I)=0
      INCL(I)=IABS(INCL(I))
      IF (I.GT.NATO) INCL(I)=-INCL(I)
71    ICOL(I)=1
      GOTO 4
C**** SELECT COLOUR
100   ICO=1
      IF (KL.LT.2) GOTO 150
      DO 140 K=2,KL
      CALL ATOMID (K,IAT)
      IF (IAT) 120,140,130
120   DO 125 I=9,NAT
125   IF (ITYPE(I).EQ.IAT) ICOL(I)=FN(K-1)
      GOTO 140
130   ICOL(IAT)=FN(K-1)
140   CONTINUE
      GOTO 4
150   IF (KN.NE.0) ICO=FN(1)
      DO 160 I=9,NAT
160   ICOL(I)=ICO
170   GOTO 4
C
C**** JOIN INSTRUCTION
180	KL=KL-1
	IF (KL.LT.1) GOTO 900
	DO 182 K=1,KL
	DO 181 I=1,6
181	FL(K,I)=FL(K+1,I)
182	CONTINUE
	GOTO 900
C
C**** GENERAL ERROR MESSAGE
236	ICOM=-1
	GOTO 900
C
C**** END OF JOB
247	IF(IECHO.NE.TTO) CLOSE(UNIT=IECHO)
C
900	RETURN
	END

	SUBROUTINE PLIN2 (ICOUNT,ICOM)
C
	IMPLICIT INTEGER*2 (I-N)
C
	PARAMETER (NATMAX=150)
C
      COMMON /A/ NAME(NATMAX,6),X(NATMAX,3),RADI(NATMAX),INCL(NATMAX),
     *ILAB(NATMAX),ITYPE(NATMAX),ICOL(NATMAX),IC(500),NAT,NATOS,NATO,
     *NC,NC1,IERR
C
      COMMON /B/ ID(74),MOL(100,4),
     *IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,ISTER,IPERS,ISOL,TAPER,
     *ITRACE,ICOPY,IPLOTR,CHSIZE,SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,
     *ISHADE,ANG1,ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,NMOL1
C
      COMMON/CELL/ACELL,BCELL,CCELL,ALF,BET,GAM,OR1,OR2,OR3,OR4,OR5,OR6,
     *D100,D010,D001
C
      COMMON /E/ IENC,ENC(6)
C
      COMMON /SYM/ RS(24,3,4),NSYM,ICENT
C
      COMMON/DEF/ RBDEF,LBDEF,RADEF,SZDEF,CHDEF,DPDEF,TDEF,
     *RBDEFN,LBDEFN,ANGDF1,ANGDF2,SHADEF,TAPDEF,TLDEF,TRDEF,PLDEF
C
      COMMON /FR/  TTO,TTI,INP,IPL,IECHO,COL(80),FL(20,6),FN(20),
     *NCHAR,KN,KL
C
      COMMON /SCRAT/ PLINE(3),V1(3),V2(3),V3(3),R1(3),R2(3),A(3,3),
     *B(3,3),NAMX(6),XO(NATMAX,3)
C
      COMMON /ALPHA/ LA,LB,LC,LD,LE,LF,LG,LH,LI,LJ,LK,LL,LM,LN,LO,LP,
     *LQ,LR,LS,LT,LU,LV,LW,LX,LY,LZ,LBLANK
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     *               NPLOT,IXD,IYD,IPFIL(6),IPSIZ
C
	BYTE COL
C
	INTEGER*2 FL,TTO,TTI, LET(27)
C
      EQUIVALENCE (LA,LET(1))
C
C     ASCII-CODE  * 42  & 38  0,1,9
      DATA LSTAR,LAND/42,38/
      DATA L0,L1,L3,L9/48,49,51,57/
C
      RAD = 57.2958
C
	IF (ICOM.LE.10) GOTO 900
	IF (ICOM.NE.11 .AND. ICOM.NE.12) GOTO 50
C**** ORTHONORMAL COORDS. CALCULATED
	DO 40 I=1,NAT
	XO(I,1) = OR1*X(I,1)
	XO(I,2) = OR2*X(I,1) + OR3*X(I,2)
	XO(I,3) = OR4*X(I,1) + OR5*X(I,2) + OR6*X(I,3)
40	CONTINUE
C	
50	GOTO (72,118,124,126,131,146,147,152,54,175,182,181,201,
     *        129,202,202,203,206,234,54,205,54), ICOM-10
C
54    CONTINUE
55    GOTO 900
C
C**** VIEW DEFINITION
72    N1=FL(2,1)
      N2=FL(2,2)
      L=2
      N=0
      IF (N1.EQ.LC .AND. N2.EQ.LU) GOTO 93
      IF (N1.EQ.LM .AND. N2.EQ.LA) GOTO 127
C**** KEYWORDS DEFINING A ROTATION MATRIX TO BE CALCULATED.
      DO 73 I=1,3
      PLINE(I)=0.5
      DO 73 J=1,3
73    R(I,J)=0.0
      IF (N1.EQ.LX) GOTO 74
      IF (N1.EQ.LY) GOTO 75
      IF (N1.EQ.LZ) GOTO 76
      IF (N1.EQ.LA .AND. N2.EQ.LF) GOTO 77
      IF (N1.EQ.LB .AND. N2.EQ.LF) GOTO 78
      IF (N1.EQ.LC .AND. N2.EQ.LF) GOTO 79
      IF (N1.EQ.LD) GOTO 82
      IF (N1.EQ.LL) GOTO 80
      IF (N1.EQ.LP) GOTO 86
      IF (N1.EQ.LB) GOTO 87
      GOTO 236
74    R(1,2)=1.
      R(2,3)=1.
      R(3,1)=1.
      GOTO 93
75    R(1,3)=1.
      R(2,1)=1.
      R(3,2)=1.
      GOTO 93
76    R(1,1)=1.
      R(2,2)=1.
      R(3,3)=1.
      GOTO 93
77    ILINE=1
      PLINE(1)=1.0
      GOTO 84
78    ILINE=1
      PLINE(2)=1.0
      GOTO 84
79    ILINE=1
      PLINE(3)=1.0
      GOTO 84
80    ILINE=1
      IF (KL.LT.4) GOTO 236
      CALL  ATOMID(3,IAT)
      CALL  ATOMID(4,JAT)
      IF (IAT.LE.0 .OR. JAT.LE.0) GOTO 236
      DO 81 K=1,3
81    PLINE(K)=X(IAT,K)-X(JAT,K)
      L=L+2
      GOTO 84
82    DO 83 K=1,3
      PLINE(K)=FN(K)
83    CONTINUE
      ILINE=1
      L=2
      N=3
84    XX=PLINE(1)
      YY=PLINE(2)
      ZZ=PLINE(3)
      V3(1)=OR1*XX
      V3(2)=OR2*XX + OR3*YY
      V3(3)=OR4*XX + OR5*YY + OR6*ZZ
C**** CALC R MATRIX FOR LINE VIEW
      V3MOD=SQRT(V3(1)*V3(1) + V3(2)*V3(2) + V3(3)*V3(3))
      DO 85 K=1,3
85    V3(K)=V3(K)/V3MOD
      R2(1)=0.0
      R2(2)=0.0
      R2(3)=0.0
      IF (ABS(V3(2)).GT.0.9999) R2(1)=1.
      IF (R2(1).EQ.0.) R2(2)=1.
      CALL  VPROD(R2,V3,V1)
      CALL  VPROD(V3,V1,V2)
      GOTO 92
86    ILINE=2
      GOTO 88
87    ILINE=3
88    IF (KL.LT.5) GOTO 236
      CALL  ATOMID(3,J1)
      CALL  ATOMID(4,J2)
      CALL  ATOMID(5,J3)
      IF (J1.LE.0 .OR. J2.LE.0 .OR. J3.LE.0) GOTO 236
      L=L+3
C**** CALC R MATRIX FOR PERP AND BISECT VIEWS
      DO 89 K=1,3
      V3(K)= 0.5*(XO(J1,K) + XO(J3,K)) - XO(J2,K)
      R1(K)=XO(J1,K) - XO(J2,K)
      R2(K)=XO(J3,K) - XO(J2,K)
89    CONTINUE
      V3MOD=SQRT(V3(1)**2 + V3(2)**2 + V3(3)**2)
      R1MOD=SQRT(R1(1)**2 + R1(2)**2 + R1(3)**2)
      R2MOD=SQRT(R2(1)**2 + R2(2)**2 + R2(3)**2)
      DO 90 K=1,3
      V3(K)=V3(K)/V3MOD
      R1(K)=R1(K)/R1MOD
      R2(K)=R2(K)/R2MOD
90    CONTINUE
C**** NOW GET V2=V3XR2  AND THEN V1=V2XV3
      CALL  VPROD(V3,R2,V2)
      CALL  VPROD(V2,V3,V1)
      IF (ILINE.EQ.3) GOTO 92
C**** FOR PERP  JUST SWOP AXES
      DO 91  K=1,3
      TEMP=V3(K)
      V3(K)=V2(K)
      V2(K)=V1(K)
91    V1(K)=TEMP
      GOTO 92
C**** SET R MATRIX
92    R(1,1)=V1(1)
      R(1,2)=V1(2)
      R(1,3)=V1(3)
      R(2,1)=V2(1)
      R(2,2)=V2(2)
      R(2,3)=V2(3)
      R(3,1)=V3(1)
      R(3,2)=V3(2)
      R(3,3)=V3(3)
C**** KEWORDS GIVING ROTATIONS TO BE APPLIED TO THE CURRENT R MATRIX
93    L=L+1
      N=N+1
      IF (L.GT.KL) GOTO 115
      IF (N.GT.KN) GOTO 236
      DO 94 I=1,3
      DO 94 J=1,3
94    A(I,J)=0.0
      ANG=FN(N)/RAD
      CA=COS(ANG)
      SA=SIN(ANG)
      N1=FL(L,1)
      IF (N1.EQ.LB) GOTO 100
      IF (N1.EQ.LL) GOTO 108
      IF (N1.EQ.LO) GOTO 110
      IF (N1.EQ.LP) GOTO 112
      IF (N1.EQ.LX) GOTO 96
      IF (N1.EQ.LY) GOTO 95
      IF (N1.NE.LZ) GOTO 236
C**** Z ROTN
      A(1,1)=CA
      A(1,2)=SA
      A(2,1)=-SA
      A(2,2)=CA
      A(3,3)=1.0
      GOTO 97
C**** Y ROTN
95    A(1,1)=CA
      A(1,3)=-SA
      A(2,2)=1.0
      A(3,1)=SA
      A(3,3)=CA
      GOTO 97
C**** X ROTN
96    A(1,1)=1.0
      A(2,2)=CA
      A(2,3)=SA
      A(3,2)=-SA
      A(3,3)=CA
97    DO 98 I=1,3
      DO 98 J=1,3
98    B(I,J)=A(I,1)*R(1,J) + A(I,2)*R(2,J) + A(I,3)*R(3,J)
      DO 99 I=1,3
      DO 99 J=1,3
99    R(I,J)=B(I,J)
      GOTO 93
C**** BOND ROTN
100   IF ((L+2).GT.KL) GOTO 236
      L=L+1
      CALL ATOMID(L,I)
      IF (I.LE.0) GOTO 236
      L=L+1
      CALL ATOMID(L,J)
      IF (J.LE.0) GOTO 236
      DO 101 K=1,3
101   V1(K)=X(I,K)-X(J,K)
102   V3(1)=OR1*V1(1)
      V3(2)=OR2*V1(1)+OR3*V1(2)
      V3(3)=OR4*V1(1)+OR5*V1(2)+OR6*V1(3)
103   V3MOD=SQRT(V3(1)*V3(1)+V3(2)*V3(2)+V3(3)*V3(3))
      DO 104 K=1,3
104   V3(K)=V3(K)/V3MOD
      DO 105 I=1,3
105   V2(I)=R(I,1)*V3(1)+R(I,2)*V3(2)+R(I,3)*V3(3)
106   CB=1.-CA
      DO 107 I=1,3
      DO 107 J=1,3
107   A(I,J)=CB*V2(I)*V2(J)
      A(1,1)=A(1,1)+CA
      A(1,2)=A(1,2)+V2(3)*SA
      A(1,3)=A(1,3)-V2(2)*SA
      A(2,1)=A(2,1)-V2(3)*SA
      A(2,2)=A(2,2)+CA
      A(2,3)=A(2,3)+V2(1)*SA
      A(3,1)=A(3,1)+V2(2)*SA
      A(3,2)=A(3,2)-V2(1)*SA
      A(3,3)=A(3,3)+CA
      GOTO 97
C**** LINE ROTN
108   IF ((N+3).GT.KN) GOTO 236
      DO 109 I=1,3
109   V1(I)=FN(N+I)
      N=N+3
      GOTO 102
C**** ORTHOLINE ROTN
110   IF ((N+3).GT.KN) GOTO 236
      DO 111 I=1,3
111   V3(I)=FN(N+I)
      N=N+3
      GOTO 103
C**** PROT
112   IF ((N+3).GT.KN) GOTO 236
      DO 113 I=1,3
113   V2(I)=FN(N+I)
      N=N+3
      V2MOD=SQRT(V2(1)*V2(1)+V2(2)*V2(2)+V2(3)*V2(3))
      DO 114 I=1,3
114   V2(I)=V2(I)/V2MOD
      GOTO 106
C**** TEST DETERMINANT = +1.0000
115   DET=R(1,1)*(R(2,2)*R(3,3) - R(2,3)*R(3,2))
     *-R(1,2)*( R(2,1)*R(3,3) - R(2,3)*R(3,1) )
     *+R(1,3)*( R(2,1)*R(3,2) - R(2,2)*R(3,1) )
      IF (ABS(DET-1.0) .LT.0.001) GOTO 54
      WRITE (TTO,116) DET
116   FORMAT (' ** WARNING: DID YOU KNOW THAT THE DETERMINANT '/4X,
     *'OF YOUR VIEW MATRIX =',F10.5/4X,'IT SHOULD BE +1.0 TO BE LEGAL')
      IF (IECHO.NE.TTO) WRITE (IECHO,116) DET
      IF (DET.LE. -0.999)  WRITE (TTO,117)
117   FORMAT (' ** IN FACT, YOUR DETERMINANT REPRESENTS AN INVERSION.'/
     *4X,'ABSOLUTE CONFIGURATION IS CHANGED. YOU HAVE BEEN WARNED.')
      IF (IECHO.NE.TTO .AND. DET.LE.-0.999) WRITE (IECHO,117)
      GOTO 54
C**** ALIGN INSTRUCTION
118   IF (KL.NE.5) GOTO 236
      IF (FL(4,1).NE.LW) GOTO 236
      ANG=0.
      IF (FL(5,1).EQ.LX) GOTO 119
      ANG=-90.
      IF (FL(5,1).NE.LY) GOTO 236
119   CALL ATOMID(2,IAT)
      CALL ATOMID(3,JAT)
      IF (IAT.LE.0 .OR. JAT.LE.0) GOTO 236
      DO 121 I=1,2
      R1(I)=0.
      R2(I)=0.
      DO 120 J=1,3
      R1(I)=R(I,J)*XO(IAT,J)+R1(I)
120   R2(I)=R(I,J)*XO(JAT,J)+R2(I)
121   V1(I)=R2(I)-R1(I)
      IF (ABS(V1(1))+ABS(V1(2)).GT.1.) GOTO 123
      WRITE (TTO,122)
122   FORMAT (' ** ATOMS SUPERIMPOSED IN THIS VIEW: ',
     *'VIEW MATRIX NOT CHANGED')
      IF (IECHO.NE.TTO) WRITE (IECHO,122)
      GOTO 54
123   ANG=ATAN2(V1(2),V1(1))*RAD+ANG
      N=0
      L=0
      KL=1
      KN=1
      FN(1)=ANG
      FL(1,1)=LZ
      GOTO 93
C**** SOLID MODE
124   ISOL=1
      ISHADE=0
      IF (KL.EQ.1) GOTO 54
      DO 125 I=2,KL
      IF (FL(I,1).EQ.LS) ISHADE=ISHADE+1
125   IF (FL(I,1).EQ.LC) ISHADE=ISHADE+2
      IF (KN.EQ.0) GOTO 54
      ANG1=FN(1)
      ANG2=FN(2)
      IF (KN.EQ.2) GOTO 54
      SHADEN=FN(3)
      GOTO 54
C**** STICK MODE
126   ISOL=0
      GOTO 54
C**** VIEW MATRIX CARD
127   IF (KN.LT.9) GOTO 236
      K=0
      DO 128 I=1,3
      DO 128 J=1,3
      K=K+1
128   R(I,J)=FN(K)
      N=9
      GOTO 93
C**** RETRACE INSTRUCTION
129   IF (KN.EQ.0) GOTO 236
      IF (KL.NE.2) GOTO 236
      IF (FL(2,1).EQ.LL) GOTO 130
      IF (FL(2,1).NE.LA) GOTO 236
      ITRACE=FN(1)
      IF (KN.EQ.2) TRSTEP=FN(2)
      GOTO 54
130   ITRACH=FN(1)
      ITRACV=ITRACH
      IF (KN.GE.2) ITRACV=FN(2)
      IF (KN.EQ.3) TRLAB=FN(3)
      GOTO 54
C**** LABEL INSTRUCTIONS
131   IAL=1
132   IF (KL.LT.2) GOTO 144
      IF (FL(2,1).EQ.LA .AND. FL(2,2).EQ.LL .AND.
     *    FL(2,3).EQ.LL) GOTO 144
      IF (FL(2,1).EQ.LN .AND. FL(2,2).EQ.LO .AND.
     *    FL(2,3).EQ.LN) GOTO 143
      DO 142 K=2,KL
      IF (FL(K,2).NE.LR .OR. FL(K,3).NE.LI) GOTO 134
      DO 133 I=9,NATO
133   ILAB(I)=IAL
      GOTO 142
134   IF (FL(K,1).NE.LSTAR) GOTO 136
      I=NATO+1
      IF (I.GT.NATOS) GOTO 142
      DO 135 J=I,NATOS
135   ILAB(J)=IAL
      GOTO 142
136   IF (FL(K,1).NE.LAND) GOTO 138
      I=NATOS+1
      IF (I.GT.NAT) GOTO 142
      DO 137 J=I,NAT
137   ILAB(J)=IAL
      GOTO 142
138   CALL ATOMID(K,IAT)
      IF (IAT)139,142,141
139   DO 140 I=9,NAT
140   IF (ITYPE(I).EQ.IAT) ILAB(I)=IAL
      GOTO 142
141   ILAB(IAT)=IAL
142   CONTINUE
      GOTO 54
143   IAL=1-IAL
144   DO 145 I=9,NAT
145   ILAB(I)=IAL
      GOTO 54
146   IAL=0
      GOTO 132
C**** PUT LABELS WHERE REQUESTED
147   L=2
148   IF (L.GT.KL) GOTO 54
      CALL ATOMID(L,IAT)
      L=L+1
      IF (L.GT.KL) GOTO 236
      I=0
      IF (FL(L,1).EQ.LA .AND. FL(L,2).EQ.LU    ) I=1
      IF (FL(L,1).EQ.LN .AND. FL(L,2).EQ.LBLANK) I=4
      IF (FL(L,1).EQ.LN .AND. FL(L,2).EQ.LE    ) I=3
      IF (FL(L,1).EQ.LE .AND. FL(L,2).EQ.LBLANK) I=2
      IF (FL(L,1).EQ.LS .AND. FL(L,2).EQ.LE    ) I=9
      IF (FL(L,1).EQ.LS .AND. FL(L,2).EQ.LBLANK) I=8
      IF (FL(L,1).EQ.LS .AND. FL(L,2).EQ.LW    ) I=7
      IF (FL(L,1).EQ.LW .AND. FL(L,2).EQ.LBLANK) I=6
      IF (FL(L,1).EQ.LN .AND. FL(L,2).EQ.LW    ) I=5
      IF (I.EQ.0) GOTO 236
      IF (IAT)149,236,151
149   DO 150 J=9,NAT
      IF (ITYPE(J).EQ.IAT) ILAB(J)=MIN0(ILAB(J),1)*I
150   CONTINUE
      L=L+1
      GOTO 148
151   ILAB(IAT)=MIN0(ILAB(IAT),1)*I
      L=L+1
      GOTO 148
C**** RADII CARD. THIS SETS RADII FOR ATOMS AND BONDS. THERE ARE SEVERAL
C**** OPTIONS FOR BOND SPECIFICATION, ATOM TYPE, INTERMOLECULAR, TO
C**** LIST, SPECIFIC ATOM PAIR.  WE ALSO ENTER NUMBER OF LINES FOR BOND.
C**** TAPERING OF BONDS MAY BE CONTROLLED ALSO, AND BOND-END PLOTTING.
152   N=0
      IF (FL(2,1).EQ.LB) GOTO 160
      IF (FL(2,1).EQ.LA) GOTO 153
      GOTO 236
C**** ATOM RADIUS SPECIFICATION HERE
153   IF (KL.EQ.3 .AND. FL(3,3).EQ.LL) GOTO 158
      DO 157 K=3,KL
      CALL ATOMID(K,IAT)
      IF (IAT) 154,157,156
154   M=IAT
      N=N+1
      DO 155 I=9,NAT
      IF (ITYPE(I).EQ.M) RADI(I)=FN(N)
155   CONTINUE
      GOTO 157
156   N=N+1
      RADI(IAT)=FN(N)
157   CONTINUE
      GOTO 54
158   DO 159 I=9,NAT
159   RADI(I)=FN(1)
      GOTO 54
C**** BOND SPECIFICATION HERE.
160   J1=FL(3,1)
      J2=FL(3,2)
      J3=FL(3,3)
      IF (J1.EQ.LT .AND. J2.EQ.LO) GOTO 161
      IF (J1.EQ.LA .AND. J3.EQ.LL) GOTO 171
      IF (J1.EQ.LI .AND. J3.EQ.LT) GOTO 162
      IF (J1.EQ.LT .AND. J3.EQ.LP) GOTO 169
      IF (J1.EQ.LE .AND. J2.EQ.LN) GOTO 170
      IF (J1.EQ.LN .AND. J2.EQ.LO) GOTO 172
      CALL  ATOMID(3,IAT)
      CALL  ATOMID(4,JAT)
      IF (IAT.LE.0 .OR. JAT.LE.0) GOTO 236
C**** SPECIFIC BOND NAMED HERE
      N1=MIN0(IAT,JAT)
      N2=MAX0(IAT,JAT)
      GOTO 163
C**** KEYWORD TO  FOLLOWED BY ATOM OR ATOM TYPE
161   CALL  ATOMID(4,M)
      IF (M.EQ.0) GOTO 236
      N1=0
      N2=M
      GOTO 163
C**** KEYWORD INTER FOR ALL INTERMOLECULAR BONDS
162   N1=-1
      N2=0
C**** STORE BOND RADIUS AND NUMBER OF LINES.
163   RB=RBDEF
      L=LBDEF
      IF (KN.GT.0) RB=FN(1)
      IF (KN.EQ.2) L=FN(2)
      RB=RB*1000.
      N3=1000*L+INT(RB+0.5)
      IF (NSPEC.EQ.0) GOTO 165
      DO 164 I=1,NSPEC
      IF (N1.EQ.IBS(I,1) .AND. N2.EQ.IBS(I,2)) GOTO 166
164   CONTINUE
165   IF (NSPEC.GE.30) GOTO 167
      NSPEC=NSPEC+1
      I=NSPEC
      IBS(I,1)=N1
      IBS(I,2)=N2
166   IBS(I,3)=N3
      GOTO 54
167   WRITE (TTO,168)
168   FORMAT (' ** SPECIAL BOND LIST FULL: IGNORED')
      IF (IECHO.NE.TTO) WRITE (IECHO,168)
      GOTO 54
C**** TAPERING
169   TAPER=FN(1)
      GOTO 54
C**** BOND-END PLOTTING
170   IEND=1
      IF (KL.EQ.4 .AND. FL(4,1).EQ.LN) IEND=0
      GOTO 54
C**** CHANGE DEFAULT SETTINGS FOR RADIUS AND LINES
171   NSPEC=0
172   RBDEF=FN(1)
      LBDEF=FN(2)
      GOTO 54
C**** MOLES TO BE PLOTTED
175   IF (KL.GT.1 .AND. FL(2,1).EQ.LN) GOTO 177
      IF (KL.GT.1 .AND. FL(2,1).EQ.LU) GOTO 178
      IF (KN.LT.4) GOTO 236
      DO 176 K=1,KN,4
      IF (NMOL.GE.100) GOTO 179
      NMOL=NMOL+1
      MOL(NMOL,1) = FN(K)
      MOL(NMOL,2) = FN(K+1)
      MOL(NMOL,3) = FN(K+2)
176   MOL(NMOL,4) = FN(K+3)
      GOTO 54
177   NMOL=0
      GOTO 54
178   NMOL=NMOL1
      GOTO 54
179   WRITE (TTO,180)
180   FORMAT (' ** MOLECULE LIST FULL')
      IF (IECHO.NE.TTO) WRITE (IECHO,180)
      GOTO 54
C**** INCLUDE / OMIT
181   N=-1
      GOTO 183
182   N=1
183   IF (FL(2,1).EQ.LA .AND. FL(2,2).EQ.LL .AND. FL(2,3).EQ.LL)GOTO 199
      IF (FL(2,1).EQ.LN .AND. FL(2,2).EQ.LO .AND. FL(2,3).EQ.LN)GOTO 198
184   IF (FL(2,1).EQ.LO .AND. FL(2,2).EQ.LU .AND. FL(2,3).EQ.LT)GOTO 195
      DO 194 K=2,KL
      IF (FL(K,1).NE.LSTAR) GOTO 186
      M=NATO+1
      IF (M.GT.NATOS) GOTO 194
      DO 185 I=M,NATOS
185   INCL(I)=N*IABS(INCL(I))
      GOTO 194
186   IF (FL(K,1).NE.LAND) GOTO 188
      M=NATOS+1
      IF (M.GT.NAT) GOTO 194
      DO 187 I=M,NAT
187   INCL(I)=N*IABS(INCL(I))
      GOTO 194
188   IF (FL(K,2).NE.LR .OR. FL(K,3).NE.LI) GOTO 190
      DO 189 I=9,NATO
189   INCL(I)=N*IABS(INCL(I))
      GOTO 194
190   CALL  ATOMID(K,M)
      IF (M) 191,194,193
191   DO 192 I=9,NAT
192   IF (ITYPE(I).EQ.M) INCL(I)=N*IABS(INCL(I))
      GOTO 194
193   INCL(M)=N*IABS(INCL(M))
194   CONTINUE
      GOTO 54
195   IF (KN.EQ.1 .AND. FN(1).EQ.0.) GOTO 197
      IF (KN.NE.6) GOTO 236
      DO 196 I=1,6
196   ENC(I)=FN(I)
      IENC=1
      GOTO 54
197   IENC=0
      GOTO 54
198   N=-N
199   DO 200 I=1,NAT
200   INCL(I)=N*IABS(INCL(I))
      GOTO 54
C**** UNITCELL TO BE PLOTTED
201   ICELL=1
      IF (KL.GT.1 .AND. FL(2,1).EQ.LN) ICELL=0
      GOTO 54
C**** STEREO
202   ISTER=0
      J1=COL(1)
      IF (J1.EQ.LS) ISTER=1
      IF (J1.EQ.LM)  IPERS=1
CCC      IF (KL.GT.1 .AND. FL(2,1).EQ.LC) IPLOTR=4
      IF (KN.EQ.0) GOTO 54
      DPLOT=FN(1)
      GOTO 54
C**** SIZE CONTROL...SIZE OF DRAWING, SCALE, CHARACTERS, BOX
203   IF (KN.NE.KL) GOTO 236
      SIZEM=FN(1)
      IF (KL.LT.2) GOTO 54
      DO 204 K=2,KL
      IF (FL(K,1).EQ.LS) SCA=FN(K)
      IF (FL(K,1).EQ.LT) TSIZE=FN(K)
      IF (FL(K,1).EQ.LB) SHRINK=FN(K)/100.
204   IF (FL(K,1).EQ.LC) CHSIZE=FN(K)
      GOTO 54
C**** SEGMENT INSTRUCTION: SET PLOTSTEP SIZE
205   IF (KN.NE.1) GOTO 236
      PLSTEP=FN(1)
      GOTO 54
C**** PRINT OPTIONS
206   N1=0
      N2=0
      N3=0
      N4=0
      IF (KL.GT.1) GOTO 207
      N1=1
      N2=1
      N3=1
      N4=1
      GOTO 209
207   DO 208 I=2,KL
      IF (FL(I,1).EQ.LA) N1=1
      IF (FL(I,1).EQ.LB) N2=1
      IF (FL(I,1).EQ.LR)N3=1
208   IF (FL(I,1).EQ.LM) N4=1
209   IF (N1.EQ.0) GOTO 213
      WRITE (TTO,210)
210   FORMAT (' ATOMS'//'    NAME',6X,1HX,9X,1HY,9X,1HZ,6X,
     *'RADIUS  INCLUDE  LABEL  TYPE')
      IF (IECHO.NE.TTO) WRITE (IECHO,210)
      DO 212 I=9,NAT
      IF (INCL(I).EQ.0) GOTO 212
      J1=LBLANK
      IF (INCL(I).GT.0) J1=LSTAR
      J2=LBLANK
      IF (ILAB(I).GT.0) J2=LSTAR
      J3=-ITYPE(I)
      N1=J3/256
      J3=MOD(J3,256)
      WRITE (TTO,211) (NAME(I,K),K=1,6),(X(I,K),K=1,3),RADI(I),J1,J2,
     *LET(N1),LET(J3)
211   FORMAT (4X,6A1,3F10.5,F7.2,5X,A1,7X,A1,5X,2A1)
      IF (IECHO.NE.TTO) WRITE (IECHO,211) (NAME(I,K),K=1,6),
     *(X(I,K),K=1,3),RADI(I),J1,J2,LET(N1),LET(J3)
212   CONTINUE
213   IF (N2.EQ.0) GOTO 217
      WRITE (TTO,214)
214   FORMAT (/' BONDS' /)
      IF (IECHO.NE.TTO) WRITE (IECHO,214)
      IF (NC.EQ.12) GOTO 229
      DO 216 K=13,NC
      I=IC(K)/256
      IF (I.LE.0) I=I+255
      J=MOD(IC(K),256)
      IF (J.LT.0) J=J+256
      WRITE (TTO,215) (NAME(I,L),L=1,6),(NAME(J,L),L=1,6)
215   FORMAT (4X,6A1,2H--,6A1)
216   IF (IECHO.NE.TTO) WRITE (IECHO,215) (NAME(I,L),L=1,6),
     *(NAME(J,L),L=1,6)
217   IF (N3.EQ.0) GOTO 229
      WRITE (TTO,218)
218   FORMAT (/' BONDS',12X,'RADIUS  LINES'/)
      IF (IECHO.NE.TTO) WRITE (IECHO,218)
      WRITE (TTO,219) RBDEF,LBDEF
219   FORMAT (' NORMAL',11X,F6.3,I7)
      IF (IECHO.NE.TTO) WRITE (IECHO,219) RBDEF,LBDEF
      IF (NSPEC.EQ.0) GOTO 229
      DO 228 K=1,NSPEC
      L=IBS(K,3)
      I=L/1000
      RB=0.001*FLOAT(MOD(L,1000))
      N1=IBS(K,1)
      IF (N1) 220,222,226
220   WRITE (TTO,221) RB,I
221   FORMAT (' INTERMOLECULAR',F9.3,I7)
      IF (IECHO.NE.TTO) WRITE (IECHO,221)RB,I
      GOTO 228
222   N2=IBS(K,2)
      IF (N2.GT.0) GOTO 224
      N2=-N2
      N1=N2/256
      N2=MOD(N2,256)
      WRITE (TTO,223) LET(N1),LET(N2),RB,I
223   FORMAT (' TO ',2A1,F18.3,I7)
      IF (IECHO.NE.TTO) WRITE (IECHO,223) LET(N1),LET(N2),RB,I
      GOTO 228
224   WRITE (TTO,225) (NAME(N2,J),J=1,6),RB,I
225   FORMAT (' TO ',6A1,F14.3,I7)
      IF (IECHO.NE.TTO) WRITE (IECHO,225) (NAME(N2,J),J=1,6),RB,I
      GOTO 228
226   WRITE (TTO,227) (NAME(N1,J),J=1,6),(NAME(N2,J),J=1,6),RB,I
227   FORMAT (1X,6A1,2H--,6A1,F9.3,I7)
      IF (IECHO.NE.TTO) WRITE (IECHO,227) (NAME(N1,J),J=1,6),
     *(NAME(N2,J),J=1,6),RB,I
228   CONTINUE
229   IF (N4.EQ.0) GOTO 232
      WRITE (TTO,230)
230   FORMAT (/' MOLECULES'/)
      IF (IECHO.NE.TTO) WRITE (IECHO,230)
      IF (NMOL.EQ.0) GOTO 232
      WRITE (TTO,231) ((MOL(I,J),J=1,4),I=1,NMOL)
231   FORMAT (4(4I4,2X))
      IF (IECHO.NE.TTO) WRITE (IECHO,231) ((MOL(I,J),J=1,4),I=1,NMOL)
232   WRITE (TTO,233)
233   FORMAT (/)
      IF (IECHO.NE.TTO) WRITE (IECHO,233)
      GOTO 54
C
C**** PLOT (FILENAME (A3/A4))
C
234   ICOPY=1
	IPSIZ=4
	DO 2000 I=1,6
2000	IPFIL(I)=0
	IF (KL.EQ.1) GOTO 900
	DO 2010 I=1,6
	IF (FL(2,I).NE.LBLANK) IPFIL(I)=FL(2,I)
2010	CONTINUE
	IF (KL.EQ.3 .AND. FL(3,1).EQ.LA .AND. FL(3,2).EQ.L3) IPSIZ=3
	GOTO 900
C
C**** GENERAL ERROR MESSAGE
236	ICOM=-1
C
900	RETURN
	END

	SUBROUTINE PLIN3 (ICOUNT,ICOM)
C
	IMPLICIT INTEGER*2 (I-N)
C
	PARAMETER (NATMAX=150)
C
	COMMON /XYZ/ VP(4096)
C
      COMMON /A/ NAME(NATMAX,6),X(NATMAX,3),RADI(NATMAX),INCL(NATMAX),
     *ILAB(NATMAX),ITYPE(NATMAX),ICOL(NATMAX),IC(500),NAT,NATOS,NATO,
     *NC,NC1,IERR
C
      COMMON /B/ ID(74),MOL(100,4),
     *IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,ISTER,IPERS,ISOL,TAPER,
     *ITRACE,ICOPY,IPLOTR,CHSIZE,SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,
     *ISHADE,ANG1,ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,NMOL1
C
      COMMON/CELL/ACELL,BCELL,CCELL,ALF,BET,GAM,OR1,OR2,OR3,OR4,OR5,OR6,
     *D100,D010,D001
C
      COMMON /E/ IENC,ENC(6)
C
      COMMON /SYM/ RS(24,3,4),NSYM,ICENT
C
      COMMON/DEF/ RBDEF,LBDEF,RADEF,SZDEF,CHDEF,DPDEF,TDEF,
     *RBDEFN,LBDEFN,ANGDF1,ANGDF2,SHADEF,TAPDEF,TLDEF,TRDEF,PLDEF
C
      COMMON /FR/  TTO,TTI,INP,IPL,IECHO,COL(40),FL(20,6),FN(20),
     *NCHAR,KN,KL
C
      COMMON /SCRAT/ PLINE(3),V1(3),V2(3),V3(3),R1(3),R2(3),A(3,3),
     *B(3,3),NAMX(6)
C
      COMMON /ALPHA/ LA,LB,LC,LD,LE,LF,LG,LH,LI,LJ,LK,LL,LM,LN,LO,LP,
     *LQ,LR,LS,LT,LU,LV,LW,LX,LY,LZ,LBLANK
C
	INTEGER*2 TTO,TTI,COL,FL, LET(27)
C
      EQUIVALENCE (LA,LET(1))
C
      DATA LSTAR /42/
C
	IF (ICOM.LT.0) GOTO 236
	IF (ICOM.EQ.29) GOTO 238
	IF (ICOM.EQ.8) GOTO 48
	IF (ICOM.EQ.19) GOTO 173
4	GOTO 900
C
C**** JOIN CARD..... SETS UP CONNECTION ARRAY IC.
48    IF (KL.EQ.0)  GOTO 236
      IF (FL(1,1).EQ.LR .AND. FL(1,2).EQ.LA .AND. FL(1,3).EQ.LD)GOTO49
      IF (FL(1,1).EQ.LN .AND. FL(1,2).EQ.LO .AND. FL(1,3).EQ.LN)GOTO57
      IF (FL(1,1).EQ.LI .AND. FL(1,5).EQ.LA) GOTO 58
      IF (FL(2,1).EQ.LT .AND. FL(2,2).EQ.LO) GOTO 62
      CALL  ATOMID (1,IAT)
      IF (IAT) 236,236,59
C**** RADII GIVEN FOR DISTANCE SCAN
49    IUNIQ=0
      IPRINT=1
      INTER=0
      N=0
C
      DO 50 I=1,NAT
50    VP(4*I)=-10.
      DO 56 K=2,KL
      J1=FL(K,1)
      J2=FL(K,2)
      J3=FL(K,3)
      IF (J1.EQ.LU .AND. J2.EQ.LN .AND. J3.EQ.LI) GOTO 53
      IF (J1.EQ.LN .AND. J2.EQ.LO .AND. J3.EQ.LP) GOTO 54
      IF (J1.EQ.LI .AND. J2.EQ.LN .AND. J3.EQ.LT) GOTO 55
      IF (J1.EQ.LN .AND. J2.EQ.LO .AND. J3.EQ.LN) GOTO 57
C**** TEST FOR ATOM TYPE
      CALL  ATOMID (K,IAT)
      IF (IAT)51,236,236
C**** TYPE OF ATOM LIST.  THIS IS USED TO SET ATOM RADII FOR SCAN.
51    M=IAT
      N=N+1
      DO 52 I=1,NAT
      IF (ITYPE(I).EQ.M) VP(4*I)=FN(N)
52    CONTINUE
      GOTO 56
53    IUNIQ=1
      GOTO 56
54    IPRINT=0
      GOTO 56
55    INTER=1
56    CONTINUE
      CALL DSCAN (999,IUNIQ,INTER,IPRINT)
      GOTO 4
57    NC=12
      NC1=12
      GOTO 4
58    NC=NC1
      GOTO 4
C**** SPECIFIC ATOM CONNECTIONS
59    DO 61 K=2,KL
      IF (FL(K,1).EQ.LSTAR) GOTO 60
      CALL ATOMID (K,JAT)
      IF (JAT.LE.0) GOTO 236
      IF (IAT.EQ.0) GOTO 61
      IF (NC.GE.500) GOTO 64
      NC=NC+1
      IC(NC)=256*IAT+JAT
      GOTO 61
60    JAT=0
61    IAT=JAT
      NC1=NC
      GOTO 4
C**** TO LIST. JOIN ATOM 1 TO EACH OF THE FOLLOWING ATOMS ON THE CARD.
62    CALL ATOMID (1,IAT)
      IF (IAT.LE.0) GOTO 236
      DO 63 K=3,KL
      CALL ATOMID (K,JAT)
      IF (JAT.LE.0) GOTO 236
      IF (NC.GE.500) GOTO 64
      NC=NC+1
63    IC(NC)=256*IAT+JAT
      NC1=NC
      GOTO 4
64    WRITE (TTO,65)
65    FORMAT (/' ** CONNECTIONS LIST FULL')
      IF (IECHO.NE.TTO) WRITE (IECHO,65)
      GOTO 4
C**** PACKING DIAGRAM CONTROL
173   I=0
      IF (KL.EQ.2) GOTO 174
      IF (FL(3,1).NE.LC) GOTO 236
      CALL ATOMID (4,I)
      IF (I.LE.0) GOTO 236
C**** PACK  RANGE     X1,X2,Y1,Y2,Z1,Z2
174   CALL DSCAN (I,0,0,0)
      GOTO 4
C
C**** GENERAL ERROR MESSAGE
236	IERR=IERR+1
      WRITE (TTO,237)
237   FORMAT (' ** INSTRUCTION ERROR'/4X,'CHECK FOR CORRECT SPELLING',
     *' OF KEYWORDS AND SUFFICIENT DATA')
      IF (IECHO.NE.TTO) WRITE (IECHO,237)
      GOTO 900
238   IF (IERR.GT.0) WRITE (TTO,239)
239   FORMAT (' ** ERROR(S) FOUND IN INSTRUCTIONS - NO PLOTTING'/
     *4X,'CHECK FOR DATA CARDS IGNORED ABOVE')
      IF (IECHO.NE.TTO .AND. IERR.GT.0) WRITE (IECHO,239)
      IF (IERR.EQ.0) GOTO 900
      IF (IERR-2) 240,242,244
240   WRITE (TTO,241)
241   FORMAT (' ** BETTER LUCK NEXT TIME')
      IF (IECHO.NE.TTO) WRITE (IECHO,241)
      GOTO 246
242   WRITE (TTO,243)
243   FORMAT (' ** IT',1H','S NOT YOUR DAY, IS IT ?')
      IF (IECHO.NE.TTO) WRITE (IECHO,243)
      GOTO 246
244   WRITE (TTO,245)
245   FORMAT (' ** WHEN DID YOU LAST READ THE MANUAL ?')
      IF (IECHO.NE.TTO) WRITE (IECHO,245)
246   CONTINUE
C
900   RETURN
      END

	SUBROUTINE ZSETPN (IPEN)
C
C	SELECT PEN NUMBER 'IPEN'
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,BUF(80)
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,NPLOT
C
	BYTE    BUF
C
	INTEGER*2 TTO,TTI
C
	IF (IPEN.EQ.LPEN) RETURN
	LPEN=IPEN
	IF (LPEN.GT.MCOL) LPEN=MCOL
C
	IF (ITERM.EQ.0) GOTO 20
C
	BUF(1)=27
	BUF(2)='M'
	BUF(3)='L'
	CALL INTAS (LPEN,BUF(4))
	DO 10 I=1,6
10	BUF(I+6)=BUF(I)
	BUF(9)='T'
	WRITE (TTO,15) (BUF(I),I=1,12)
15	FORMAT ('+',12A1,$)
	RETURN
C
20	BUF(1)='P'
	BUF(2)='U'
	BUF(3)=';'
	BUF(4)='S'
	BUF(5)='P'
	BUF(6)=LPEN+48
	BUF(7)=';'
	WRITE (IPL,30) (BUF(I),I=1,7)
30	FORMAT (80A1)
C
	RETURN
	END

        SUBROUTINE ZDRAW (IUP,X,Y)
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,BUF(80)
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     2               NPLOT,IXD,IYD
C
	BYTE    BUF
C
	INTEGER*2 TTO,TTI
C
	IX=INT(X*SCP+0.5)+IXD
	IY=INT(Y*SCP+0.5)+IYD
	IF (ITERM.EQ.0) GOTO 50
C
	BUF(1)=27
	BUF(2)='L'
	BUF(3)='F'
	IF (IUP.EQ.2) BUF(3)='G'
	CALL XYTAS (IX,IY,BUF(4))
	WRITE (TTO,10) (BUF(I),I=1,8)
10	FORMAT ('+',80(A1,$))
	GOTO 90
C
50	BUF(1)='P'
	BUF(2)='U'
	IF (IUP.EQ.2) BUF(2)='D'
	ENCODE (12,51,BUF(3)) IX,IY
51	FORMAT (2I6)
	BUF(9)=','
	BUF(15)=';'
	K=2
	DO 60 I=3,15
	IF (BUF(I).EQ.' ') GOTO 60
	K=K+1
	BUF(K)=BUF(I)
60	CONTINUE
	WRITE (IPL,70) (BUF(I),I=1,K)
70	FORMAT (80A1)
C
90	RETURN
	END

	SUBROUTINE ZCHAR (SIZE,RATIO)
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,BUF(80)
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     2               NPLOT,IXD,IYD,IPFIL(6),IPSIZ
C
	BYTE    BUF
C
	INTEGER*2 TTO,TTI
C
	IF (ITERM.EQ.0) GOTO 50
C
C		FIXED CHARACTER SIZE FOR TERMINALS
C
	BUF(1)=27
	BUF(2)='M'
	BUF(3)='C'
	J=4
	DO 10 I=1,3
	CALL INTAS (ICHSIZ(I),BUF(J))
10	J=J+3
	WRITE (TTO,20) (BUF(I),I=1,J-1)
20	FORMAT ('+',80(A1,$))
	GOTO 90
C
C		VARIABLE FOR PLOTTER
C
50	YS=0.1*SIZE
	XS=YS*RATIO*0.667
	BUF(1)='S'
	BUF(2)='I'
	ENCODE (12,51,BUF(3)) XS,YS
51	FORMAT (2F6.3)
	BUF(9)=','
	BUF(15)=';'
	WRITE (IPL,60) (BUF(I),I=1,15)
60	FORMAT (80A1)
C
90	RETURN
	END

	SUBROUTINE ZWRITE (ITEXT,NTX)
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,BUF(80)
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     2               NPLOT,IXD,IYD,IPFIL(6),IPSIZ
C
	BYTE    BUF
C
	INTEGER*2 TTO,TTI,ITEXT(1)
C
	IF (ITERM.EQ.0) GOTO 50
C
	BUF(1)=27
	BUF(2)='L'
	BUF(3)='T'
	CALL INTAS (NTX,BUF(4))
	N=6
10	DO 12 I=1,NTX
	N=N+1
12	BUF(N)=ITEXT(I)
	IF (ITERM.NE.0) GOTO 15
	N=N+1
	BUF(N)=3 ! CTRL-C
15	IF (ITERM.NE.0) WRITE (TTO,20) (BUF(I),I=1,N)
	IF (ITERM.EQ.0) WRITE (IPL,21) (BUF(I),I=1,N)
20	FORMAT ('+',80(A1,$))
21	FORMAT (80A1)
	GOTO 90
C
50	BUF(1)='L'
	BUF(2)='B'
	N=2
	GOTO 10
C
90	RETURN
	END

	SUBROUTINE ZMARK (X,Y)
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,BUF(80)
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     2               NPLOT,IXD,IYD
C
	BYTE    BUF
C
	INTEGER*2 TTO,TTI
C
	IX=INT(X*SCP+0.5)+IXD
	IY=INT(Y*SCP+0.5)+IYD
	IF (ITERM.EQ.0) GOTO 50
C
	BUF(1)=27
	BUF(2)='L'
	BUF(3)='H'
	CALL XYTAS (IX,IY,BUF(4))
	WRITE (TTO,10) (BUF(I),I=1,8)
10	FORMAT ('+',80(A1,$))
	GOTO 90
C
50	CONTINUE
C
90	RETURN
	END

C
	SUBROUTINE INTAS (NUM,STRING)
C	==============================
C
	IMPLICIT INTEGER*2 (I-N)
C
	BYTE STRING(1)
C
	JINT = IABS(NUM)
	STRING(1) = JINT/1024 +64
	STRING(2) = MOD(JINT/16,64) +64
	STRING(3) = MOD(JINT,16) +32
	IF (NUM.GE.0) STRING(3) = STRING(3) +16
C
	RETURN
	END
C
C
C
C
	SUBROUTINE XYTAS (IX,IY,STRING)
C	===============================
C
	IMPLICIT INTEGER*2 (I-N)
C
	BYTE STRING(1)
C
	STRING(1) = IY/128 + 32
	STRING(2) = (IX.AND."3) + (IY.AND."3)*4 + 96
	STRING(3) = (IY/4.AND."37) + 96
	STRING(4) = IX/128 + 32
	STRING(5) = (IX/4.AND."37) + 64
C
	RETURN
	END

      	SUBROUTINE PLSOLI
C
C**** CONTROLS PLOTTING OF ATOMS AND BONDS
C
	IMPLICIT INTEGER*2 (I-N)
C
	PARAMETER (NATMAX=150)
C
	COMMON /XYZ/ VP(4096)
C
      COMMON /A/ NAME(NATMAX,6),X(NATMAX,3),RADI(NATMAX),INCL(NATMAX),
     *ILAB(NATMAX),ITYPE(NATMAX),ICOL(NATMAX),IC(500),NAT,NATOS,NATO,
     *NC,NC1,IERR
C
      COMMON /B/ ID(74),MOL(100,4),
     *IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,ISTER,IPERS,ISOL,TAPER,
     *ITRACE,ICOPY,IPLOTR,CHSIZE,SIZEM,SCA,DPLOT,S,ITRACH,ITRACV,TRLAB,
     *ISHADE,ANG1,ANG2,SHADEN,PLSTEP,TRSTEP,IEND,SHRINK,YLIM,TSIZE,NMOL1
C
      COMMON/DEF/ RBDEF,LBDEF,RADEF,SZDEF,CHDEF,DPDEF,TDEF,
     *RBDEFN,LBDEFN,ANGDF1,ANGDF2,SHADEF,TAPDEF,TLDEF,TRDEF,PLDEF
C
      COMMON /SCRAT/ IOBSC(NATMAX)
C
      COMMON /FR/ TTO,TTI,INP,IPL,IECHO
C
      INTEGER*2 TTI,TTO
C
C**** DECIDE WHETHER SOLID OR STICK
D	WRITE (TTO,*) 'SOLID: ISOL =',ISOL
      IF (ISOL.EQ.0) GOTO 7
C
D	WRITE (TTO,*) 'NC =',NC
D	WRITE (TTO,99) (IC(I),I=13,NC)
D	WRITE (TTO,99) (IC(I)/256,MOD(IC(I),256),I=13,NC)
99	FORMAT (10I6)
	MXCOL=0
	DO 100 I=9,NAT
	IF (ICOL(I).GT.MXCOL) MXCOL=ICOL(I)
100	CONTINUE
C
      NAB=NAT-8
C**** PLOT CIRCLES
C**** BEGIN LOOP ON ALL ATOMS IN PLOT ARRAYS
C
	JCOL=0
110	JCOL=JCOL+1
	IF (JCOL.GT.MXCOL) GOTO 7
C
	I4=4*9-3
      DO 6 I=9,NATOT
      IF (VP(I4+3).LT.0.) GOTO 6
      IO=MOD(I-9,NAB)+9
      IF (INCL(IO).LE.0 .OR. ICOL(IO).NE.JCOL) GOTO 6
      IF (INCL(IO).LT.NATMAX .OR. IO.EQ.I) GOTO 2
C**** TESTS TO AVOID DRAWING AN ATOM MORE THAN ONCE
      J=I-NAB
      DO 1 L=IO,J,NAB
	L4=L*4-3
      IF (ABS(VP(L4)-VP(I4)).GT.0.1) GOTO 1
      IF (ABS(VP(L4+1)-VP(I4+1)).GT.0.1) GOTO 1
      IF (ABS(VP(L4+2)-VP(I4+2)).GT.0.1) GOTO 1
      GOTO 6
1     CONTINUE
2     CONTINUE
      L=1
      XI=VP(I4)
      YI=VP(I4+1)
      ZI=VP(I4+2)
      RI=VP(I4+3)
      IF (RI.LT.0.1) GOTO 6
C**** SELECT COLOUR
      CALL ZSETPN (JCOL)
C**** GET LIST OF ATOMS J WHICH OBSCURE ATOM I
C**** THIS ALLOWS FOR INTERSECTION OF SPHERES IN VAN DER WAALS MODELS.
	J4=4*9-3
      DO 3 J=9,NATOT
	RPJ=VP(J4+3)
      IF (RPJ.LT.0.) GOTO 3
      JO=MOD(J-9,NAB)+9
      IF (INCL(JO).LE.0) GOTO 3
      IF (J.EQ.I) GOTO 3
      IF (VP(J4+2)+RPJ.LT.ZI) GOTO 3
      RIJ=RI+RPJ
      XJ=VP(J4)
      DX=XJ - XI
      IF (ABS(DX).GT.RIJ)  GOTO 3
      YJ=VP(J4+1)
      DY=YJ - YI
      IF (ABS(DY).GT.RIJ) GOTO 3
      DIJSQ=DX**2 + DY**2
      RIJSQ=RIJ**2
      IF (DIJSQ.GT.RIJSQ)  GOTO 3
C**** ENVELOPE CIRCLES INTERSECT IN PROJN DOWN ZP - TEST NOW FOR SPHERE
C**** INTERSECTION.
      NJ=J
      DZ=VP(J4+2)-VP(I4+2)
      DIJSQ=DIJSQ+DZ**2
C**** REMOVE ATOMS WHICH HAVE IDENTICAL COORDS TO ATOM I.
C**** INTERSECTING SPHERES ARE MARKED WITH NEGATIVE J.
      IF (DIJSQ.LT.0.1) GOTO 3
      IF (DIJSQ.LT.RIJSQ) NJ=-J
C**** ENTER THIS ATOM J IN THE OBSCURING LIST.
      IOBSC(L)=NJ
      L=L+1
      IF (L.GT.100)  GOTO 4
3     J4=J4+4
4     IF (L.GT.100) WRITE (TTO,5) (NAME(I,K),K=1,6)
5     FORMAT (' ** MORE THAN 100 ATOMS OBSCURE ',6A1)
      IF (L.GT.100 .AND. IECHO.GT.0) WRITE (IECHO,5) (NAME(I,K),K=1,6)
      NOBSC=L-1
C**** NOW WE CAN DRAW THE CIRCLE FOR ATOM I
      CALL PLCIRC (I,NOBSC,ISHADE,ANG1,ANG2,DPLOT,SHADEN,
     *PLSTEP,TRSTEP,ITRACE)
6     I4=I4+4
	GOTO 110
C
C**** END OF LOOP ON ATOMS
C**** PLOTTING OF BONDS
7     CALL ZSETPN (1)
      IF (NC.LE.12 .AND. ICELL.EQ.0) GOTO 31
C**** BEGIN LOOP ON MOLECULES
	NJ=NAT-8
	MM=0
	M=0
70	M=M+1
	IF (M.GT.NMOL) GOTO 31
D	WRITE (TTO,*) '70 : M=', M
C
C**** LOOP THROUGH THE LIST OF CONNECTIONS STORED IN ARRAY IC
	I1=13
	IF (M.EQ.1 .AND. ICELL.EQ.1) I1=1
	II=I1-1
80	II=II+1
	IF (II.GT.NC) GOTO 30
	IO=IC(II)/256
	IF (IO.LE.0) IO=IO+255
	JO=MOD(IC(II),256)
	IF (JO.LT.0) JO=JO+256
D	WRITE (TTO,*) 'IO,JO =', IO,JO
C**** OMIT INTRAMOLECULAR BONDS WHEN EITHER ATOM IS OMITTED, INCL<=0
      IF (IO.LT.9 .OR. IO.GT.NATO .OR. JO.LT.9 .OR. JO.GT.NATO) GOTO8
      IF (INCL(IO).LE.0 .OR. INCL(JO).LE.0) GOTO 29
8     I=IO+MM
      J=JO+MM
	I4=I*4-3
	J4=J*4-3
      IF (VP(I4+3).LT.0. .OR. VP(J4+3).LT.0.) GOTO 29
      IF (ISOL.EQ.0) GOTO 28
      IF (M.EQ.1) GOTO 15
C**** TESTS TO AVOID DRAWING A BOND MORE THAN ONCE
      N1=IABS(INCL(IO))
      N2=IABS(INCL(JO))
D	WRITE (TTO,*) 'N1,N2 =', INCL(IO),INCL(JO)
      IF (N1+N2.EQ.2) GOTO 15
      K1=MOD(N1,NATMAX)
      K2=MOD(N2,NATMAX)
      IF (N1.GT.NATMAX .OR. N2.GT.NATMAX) GOTO 9
      K=JO
      L=IO
      GOTO 10
9     K=IO
      L=JO
      IF (K2.NE.1) L=K2
      IF (K1.NE.1) K=K1
10    K1=256*MIN0(K,L)+MAX0(K,L)
D	WRITE (TTO,*) 'K,L,256*K+L =', K,L,K1
C ??      DO 11 N2=13,NC
C ??      IF (K1.EQ.IC(N2)) GOTO 12
C11       CONTINUE
C ??      GOTO 15
12    XI=VP(I4)
      YI=VP(I4+1)
      ZI=VP(I4+2)
      XJ=VP(J4)
      YJ=VP(J4+1)
      ZJ=VP(J4+2)
D	WRITE (TTO,1200) I,XI,YI,ZI, J,XJ,YJ,ZJ
D1200	FORMAT (' I=',I3,3F10.4/' J=',I3,3F10.4)
	N1=M-1
	DO 14 N2=1,N1
	K4=K*4-3
	IF (ABS(XI-VP(K4)).GT.0.1) GOTO 14
	IF (ABS(YI-VP(K4+1)).GT.0.1) GOTO 14
	IF (ABS(ZI-VP(K4+2)).GT.0.1) GOTO 14
	LL=L
	DO 13 N3=1,N1
	L4=LL*4-3
	IF (ABS(XJ-VP(L4)).GT.0.1) GOTO 13
	IF (ABS(YJ-VP(L4+1)).GT.0.1) GOTO 13
	IF (ABS(ZJ-VP(L4+2)).GT.0.1) GOTO 13
	GOTO 29
13	LL=LL+NJ
14	K=K+NJ
C**** SKIP THIS BOND IF SPHERES INTERSECT
15    DX=VP(I4)-VP(J4)
      DY=VP(I4+1)-VP(J4+1)
      DZ=VP(I4+2)-VP(J4+2)
      DIJSQ=DX**2+DY**2+DZ**2
      RIJ=VP(I4+3)+VP(J4+3)
      RIJSQ=RIJ*RIJ
      IF (DIJSQ.LE.RIJSQ) GOTO 29
      IF (VP(I4+2).GT.VP(J4+2)) GOTO 16
      K=I
      I=J
      J=K
C**** NOW ZP(I).GT.ZP(J)    VP(I4+2).GT.VP(J4+2
C**** ALLOCATE BOND RADIUS AND NUMBER OF LINES.
16    IF (I.LT.9) GOTO 21
      RBO=RBDEF
      NLI=LBDEF
      IF (NSPEC.EQ.0) GOTO 22
      L=-1
      DO 20 K=1,NSPEC
      N1=IBS(K,1)
      N2=IBS(K,2)
      N3=IBS(K,3)
      IF (N1) 17,18,19
C**** INTERMOLECULAR
17    IF (IO.GT.NATOS .OR. JO.GT.NATOS) L=N3
      GOTO 20
C**** ATOM TYPE
18    IF (ITYPE(IO).EQ.N2 .OR. ITYPE(JO).EQ.N2) L=N3
      IF (IO.EQ.N2 .OR. JO.EQ.N2) L=N3
      GOTO 20
C**** SPECIFIC BOND
19    IF ((N1.EQ.IO .AND. N2.EQ.JO) .OR. (N1.EQ.JO .AND. N2.EQ.IO))L=N3
20    CONTINUE
      IF (L.EQ.-1) GOTO 22
      RBO=0.001*FLOAT(MOD(L,1000))
      NLI=L/1000
      GOTO 22
21    RBO=0.
      NLI=1
22    IF (NLI.EQ.0) GOTO 29
C**** SCALE BOND RADIUS TO MM.
      RBO=RBO*S
C**** SEARCH BEGINS FOR ATOMS K WHICH OBSCURE THIS BOND (I-N)
	I4=I*4-3
	J4=J*4-3
      XI=VP(I4)
      YI=VP(I4+1)
      ZI=VP(I4+2)
      XN=VP(J4)
      YN=VP(J4+1)
      ZN=VP(J4+2)
      AX=XN-XI
      AY=YN-YI
      ASQ=AX**2 + AY**2
      IF (ASQ.LT.0.01) GOTO 29
      L=1
      X1=AMIN1(XI,XN)
      X2=AMAX1(XI,XN)
      Y1=AMIN1(YI,YN)
      Y2=AMAX1(YI,YN)
      DO 25 K=9,NATOT
	K4=K*4-3
      IF (VP(K4+3).LT.0.) GOTO 25
      KO=MOD(K-9,NAB)+9
      IF (INCL(KO).LE.0) GOTO 25
      IF (K.EQ.I .OR. K.EQ.J) GOTO 25
      IF (VP(K4+2).LT.ZN) GOTO 25
      RK=VP(K4+3)
      XK=VP(K4)
      XLO=X1-RK
      XHI=X2+RK
      IF (XK.LT.XLO .OR. XK.GT.XHI)  GOTO 25
      YK=VP(K4+1)
      YLO=Y1-RK
      YHI=Y2+RK
      IF (YK.LT.YLO.OR. YK.GT.YHI)  GOTO 25
C**** IF WE GET THIS FAR WE APPLY THE EXACT TEST FOR INTERSECTION.
      BX=XK-XI
      BY=YK-YI
      BSQ=BX**2 + BY**2
      ADOTB=AX*BX + AY*BY
      PERPSQ=BSQ - (ADOTB**2)/ASQ
      DD=RK+RBO
      IF (PERPSQ.GT.DD**2)  GOTO 25
      IF (ABS(XN-XK).GT.0.001) GOTO 23
      IF (ABS(YN-YK).GT.0.001) GOTO 23
      IF (ABS(ZN-VP(K4+2)).GT.0.001) GOTO 23
      GOTO 25
23    IF (ABS(XI-XK).GT.0.001) GOTO 24
      IF (ABS(YI-YK).GT.0.001) GOTO 24
      IF (ABS(ZI-VP(K4+2)).GT.0.001) GOTO 24
      GOTO 25
C**** THIS ATOM INTERSECTS THE BOND LINE I TO N.
24    IOBSC(L)=K
      L = L + 1
      IF (L.GT.100)  GOTO 26
25    CONTINUE
26    IF (L.GT.100)  WRITE (TTO,27) I,J
27    FORMAT (' ** MORE THAN 100 OBSCURING ATOMS FOR BOND BETWEEN',
     *' ATOMS',I4,' AND',I4)
      IF (L.GT.100 .AND. IECHO.GT.0) WRITE (IECHO,27) I,J
      NOBSC=L-1
C
C**** NOW WE CAN DRAW THE BOND I TO N.
C
D	WRITE (TTO,*) 'BONDIN I,J =', I,J
      CALL PLBOND (I,J,NOBSC,TAPER,RBO,NLI,PLSTEP,DPLOT,
     *XI,YI,XN,YN,IEND)
      GOTO 29
C
C**** STICK BONDS ONLY---NO CIRCLES - NO OBSCURING
C
28    L=1
	XPI=VP(I*4-3)
	YPI=VP(I*4-2)
	XPJ=VP(J*4-3)
	YPJ=VP(J*4-2)
D	WRITE (TTO,*) '28: I,J, XI,YI, XJ,YJ =', I,J
D	WRITE (TTO,*) XPI,YPI,XPJ,YPJ
      CALL ZDRAW (L,XPI,YPI)
      L=2
      CALL ZDRAW (L,XPJ,YPJ)
C
29	CONTINUE
	GOTO 80
C
C**** END OF LOOP ON CONNECTIONS
C
30	MM=MM+NJ
	GOTO 70
C
C**** END OF LOOP ON MOLECULES
C
31    RETURN
      END

	SUBROUTINE PLSTAR
C
C		REPORT MODEL NUMBER FOR TEKTRONIX TERMINALS
C
	IMPLICIT INTEGER*2 (I-N)
C
	INCLUDE '($IODEF)'
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,LINE(40)
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     2               NPLOT,IXD,IYD,IPFIL(6),IPSIZ,MODEL
C
	BYTE LINE,INQ(9),LF,EDI(7)
C
	INTEGER*2 TTO,TTI, IOCHAN,ISB(4)
C
	INTEGER*4 STATUS,IFNC, SYS$ASSIGN,SYS$DASSGN,SYS$QIOW
C
	EQUIVALENCE (LI12,LINE(1))
C
	DATA INQ / 27,'%','!','0',27,'I','Q','?','T' /
	DATA LF / 10 /, EDI / 27,'L','Z',27,'%','!','2' /
C
	MODEL=0
C
	WRITE (TTO,20) INQ	! REQUEST MODEL NUMBER
20	FORMAT ('+',9A1,$)
C
C	WAIT FOR AN ANSWER - ONLY TEKTRONIX TERMINALS WILL RESPOND !
C
	STATUS= SYS$ASSIGN ('SYS$INPUT',IOCHAN,,)
	IF (.NOT.STATUS) CALL LIB$SIGNAL (%VAL(STATUS))
C
	IFNC  = IO$_READVBLK .OR. IO$M_TIMED
C
	STATUS= SYS$QIOW (,%VAL(IOCHAN),%VAL(IFNC),ISB,,,
     2          %REF(LINE),%VAL(40),%VAL(2),,,)
	IF (.NOT.STATUS) CALL LIB$SIGNAL (%VAL(STATUS))
C
	STATUS= SYS$DASSGN (%VAL(IOCHAN))
	IF (.NOT.STATUS) CALL LIB$SIGNAL (%VAL(STATUS))
C
	IF (ISB(1).NE.1) RETURN
C
	WRITE (TTO,31) LF		! SEND BYPASS CANCEL CHARACTER
31	FORMAT (1X,A1)
	WRITE (TTO,32) EDI		! SWITCH TO EDIT-MODE
32	FORMAT ('+',7A1,$)
D	WRITE (TTO,35) (LINE(I),I=1,10)
D35	FORMAT (10(2X,A1))
	IF (LI12.NE.'?T') RETURN
	N1 =LINE(3)
	N2 =LINE(4)
	N3 =LINE(5)
	MODEL =1024*(N1-32) + 16*(N2-32) + MOD(N3,16)
	IF (N3.LT.48) MODEL =-MODEL
D	WRITE (TTO,*) 'MODEL =',MODEL
C
	IF (MODEL.GT.4200) MODEL=MODEL-100
C
	IF (MODEL.LT.4105) RETURN
C
	IECHO=3
	OPEN (UNIT=IECHO,NAME='PLUTO.LOG',FORM='FORMATTED',
     2        CARRIAGECONTROL='LIST',TYPE='UNKNOWN',ERR=90)
C
90	RETURN
	END	

	SUBROUTINE ZSETUP (IDO)
C
	IMPLICIT INTEGER*2 (I-N)
C
	COMMON /FR/  TTO,TTI,INP,IPL,IECHO,BUF(80)
C
	COMMON /DEF/ RADBON,LINBON,RADAT,SIZE,CHAR,DIST,TITLE,RBOND,
     2               LBOND,ANGLE1,ANGLE2,SHADE,TAPER,TLDEF,TRDEF,PLDEF,
     3               YLIMIT,EYESEP,RATIO
C
	COMMON /B/ ID(74),MOL(100,4),
     *   IBS(30,3),R(3,3),NMOL,NSPEC,NATOT,ICELL,ISTER
C
	COMMON /PLT/ ITERM,NXMAX,NYMAX,ICHSIZ(4),MCOL,LPEN,SCP,
     2               NPLOT,IXD,IYD,IPFIL(6),IPSIZ,MODEL
C
	BYTE BUF,INIT1(20),INIT2(9),INIP1(20),INIP2(14),
     2       PLOTF(12),FILNA(12)
C
	INTEGER*2 TTO,TTI,CMAP(48)
C
	EQUIVALENCE (FILNA(1),IPFIL(1))
C
	DATA INIT1 / 27,'%','!','3',27,'H',27,'J',27,'%','!','0',
     2               27,'L','V','0',27,'M','M','2' /
	DATA INIT2 / 27,'S','K','!','0',27,'S','O','1' /
C
	DATA CMAP /     0,0,0,  0,100,100, 120,50,100, 300,50,100, 
     2             240,50,100, 180,50,100,  60,50,100, 160,50,100,
     3              0,100,100,  0,100,100,  0,100,100,  0,100,100,
     4              0,100,100,  0,100,100,  0,100,100,  0,100,100 /
C
	DATA INIP1 / 27,'.','(',27,'.','I','9','0',';',';','1','7',
     2               ':',27,'.','N',';','1','9',':' /
	DATA INIP2 / 'D','F',';', 'V','S','1','5','.','0',';',
     2               'P','S','4',';' /
C
	IF (IDO.GT.1) GOTO 20
C
C		SET DEFAULTS
C
	PLDEF=0.5
	TRDEF=0.1
	TLDEF=0.1
	EYESEP=30.
	DIST=600.
	RBOND=0.04
	LBOND=5
	RADBON=RBOND
	LINBON=LBOND
	RADAT=0.3
	CHAR=2.5
	TITLE=2.5
	ANGLE1=120.
	ANGLE2=-45.
	SHADE=0.9
	TAPER=0.375
	RATIO=0.9
	YLIMIT=190.0
	SIZE=180.0
	GOTO 300
C
C		INITIALISE TEKTRONIX TERMINAL
C
20	IF (IPFIL(1).NE.0) GOTO 100
	IF (MODEL.GT.0) GOTO 24
	WRITE (TTO,23)
23	FORMAT (/' ** CANNOT DRAW ON THIS TERMINAL')
	IDO=0
	RETURN
C
24	ITERM=MODEL
	MCOL=8
	IF (ITERM.GT.4105) MCOL=16
	NXMAX=4095
	NYMAX=3132
C			CHARACTER WIDTH, HEIGHT, SPACE, ANGLE
	ICHSIZ(1)=35
	ICHSIZ(2)=50
	ICHSIZ(3)=10
	ICHSIZ(4)=0
	LPEN=0
	YLIMIT=190.
	SIZE=180.
C
	WRITE (TTO,25) INIT1
	IF (ITERM.EQ.4105) GOTO 26
	WRITE (TTO,25) INIT2
25	FORMAT ('+',80(A1,$))
	GOTO 30
26	BUF(1)=27
	BUF(2)=12
	WRITE (TTO,25) BUF(1),BUF(2)
C
30	IF (NPLOT.GT.0) GOTO 200
	BUF(1)=27
	BUF(2)='T'
	BUF(3)='G'
	BUF(4)='1'
	BUF(5)='4'
	J=1
	DO 35 K=1,MCOL
	CALL INTAS (K-1,BUF(6))
	CALL INTAS (CMAP(J),BUF(9))
	CALL INTAS (CMAP(J+1),BUF(12))
	CALL INTAS (CMAP(J+2),BUF(15))
	WRITE (TTO,25) (BUF(I),I=1,17)
35	J=J+3
	GOTO 200
C
C		INITIALISE HP PLOTTER
C
100	ITERM=0
	MCOL=6
	LPEN=0
	ICHSIZ(4)=0
	IF (IPSIZ.EQ.4) GOTO 110
	NXMAX=15950
	NYMAX=11040
	ICHSIZ(1)=90
	ICHSIZ(2)=110
	ICHSIZ(3)=45
	YLIMIT=274.
	SIZE=269.
	GOTO 120
110	NXMAX=11040
	NYMAX=7720
	ICHSIZ(1)=60
	ICHSIZ(2)=90
	ICHSIZ(3)=30
	SIZE=187.
	YLIMIT=192.
C
120	DO 122 J=1,12
122	PLOTF(J)=0
	DO 123 J=1,6
	IF (IPFIL(J).NE.0) N=J
123	PLOTF(J)=IPFIL(J)
	PLOTF(N+1)='.'
	PLOTF(N+2)='P'
	PLOTF(N+3)='L'
	PLOTF(N+4)='T'	
	DO 124 J=1,12
124	FILNA(J)=PLOTF(J)
	OPEN (UNIT=IPL,NAME=PLOTF,FORM='FORMATTED',
     2        CARRIAGECONTROL='LIST',TYPE='UNKNOWN')
	WRITE (IPL,125) INIP1
	INIP2(13)=IPSIZ+48
	WRITE (IPL,125) INIP2
125	FORMAT (80A1)
C	
200	NPLOT=NPLOT+1
	SCP=FLOAT(NYMAX)/YLIMIT
	IXD=(NXMAX-NYMAX)/2
	IYD=0
	IF (ISTER.EQ.0) GOTO 300
	YLIMIT=1.414*YLIMIT
	SCP=FLOAT(NXMAX)/YLIMIT
	IYD=(NYMAX-NXMAX/2)/2
	IXD=0
C
300	RETURN
	END

      SUBROUTINE VPROD (A,B,C)
      DIMENSION A(3),B(3),C(3)
C**** C WILL BE THE VECTOR PRODUCT OF A X B  AND WILL BE NORMALISED
C**** TO UNIT LENGTH
      C(1) = A(2)*B(3) - A(3)*B(2)
      C(2) = A(3)*B(1) - A(1)*B(3)
      C(3) = A(1)*B(2) - A(2)*B(1)
      D = SQRT(C(1)**2+C(2)**2+C(3)**2)
      IF (D.LT.0.0001) RETURN
      D = 1.0/D
      DO 10 J=1,3
10    C(J) = C(J)*D
      RETURN
      END
